#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
#define BU_OUT plhs[0]
#define BXU_OUT plhs[1]
#define BYU_OUT plhs[2]
 #define Q2 prhs[0]
#define Trns_S2NS_Action prhs[1]
#define Reward_S_Action prhs[2]
#define epsilon prhs[3]
#define gama prhs[4]
#define epi prhs[5]
#define Q2X prhs[6]
#define Q2Y prhs[7]
#define Trns_X2NX_Action prhs[8]
#define Reward_X_Action prhs[9]
#define Trns_Y2NY_Action prhs[10]
#define Reward_Y_Action prhs[11]
#define gamax prhs[12]
#define gamay prhs[13]
#define Environment prhs[14]
#define Q2UX prhs[15]
#define Q2UY prhs[16]
#define Q2U prhs[17]
#define Delta prhs[18]
#define NumberSA prhs[19]
#define NumberXA prhs[20]
#define NumberYA prhs[21]
#define MINRewardSA prhs[22]
#define MAXRewardSA prhs[23]
#define MINRewardXA prhs[24]
#define MAXRewardXA prhs[25]
#define MINRewardYA prhs[26]
#define MAXRewardYA prhs[27]

       
size_t K = mxGetNumberOfDimensions(Q2);
const mwSize *N = mxGetDimensions(Q2);
double *Q = mxGetPr(Q2);
double *QX = mxGetPr(Q2X);
double *QY = mxGetPr(Q2Y);
int MX = mxGetM(Q2X); /* Get the dimensions of A */
int NX = mxGetN(Q2X);
int MY = mxGetM(Q2Y); /* Get the dimensions of A */
int NY = mxGetN(Q2Y);

int W=0;


size_t KU = mxGetNumberOfDimensions(Q2U);
const mwSize *NU = mxGetDimensions(Q2U);
double *QU = mxGetPr(Q2U);
double *QXU = mxGetPr(Q2UX);
double *QYU = mxGetPr(Q2UY);
int MXU = mxGetM(Q2UX); /* Get the dimensions of A */
int NXU = mxGetN(Q2UX);
int MYU = mxGetM(Q2UY); /* Get the dimensions of A */
int NYU = mxGetN(Q2UY);

// size_t KNum = mxGetNumberOfDimensions(NumberSA);
// const mwSize *NNum = mxGetDimensions(NumberSA);
double *Number_S_Action = mxGetPr(NumberSA);
double *Number_X_Action = mxGetPr(NumberXA);
double *Number_Y_Action = mxGetPr(NumberYA);
double *MINReward_S_Action = mxGetPr(MINRewardSA);
double *MINReward_X_Action = mxGetPr(MINRewardXA);
double *MINReward_Y_Action = mxGetPr(MINRewardYA);
double *MAXReward_S_Action = mxGetPr(MAXRewardSA);
double *MAXReward_X_Action = mxGetPr(MAXRewardXA);
double *MAXReward_Y_Action = mxGetPr(MAXRewardYA);



size_t K_T = mxGetNumberOfDimensions(Trns_S2NS_Action);
const mwSize *N_T = mxGetDimensions(Trns_S2NS_Action);
double *P = mxGetPr(Trns_S2NS_Action);
double *R = mxGetPr(Reward_S_Action);
size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);
size_t K_TY = mxGetNumberOfDimensions(Trns_Y2NY_Action);
const mwSize *N_TY = mxGetDimensions(Trns_Y2NY_Action);
double *PY = mxGetPr(Trns_Y2NY_Action);
double *RY = mxGetPr(Reward_Y_Action);

// int MEnv = mxGetM(Environment); /* Get the dimensions of A */
// int NEnv = mxGetN(Environment);
double *Env = mxGetPr(Environment);


double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *BU, *BXU, *BYU;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
  
int ix,iix, actx, acttx;
double  sumQX, maxQX;

mxArray *SortOut[2];
mxArray *SortInput[2];

mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;
UAray = mxCreateDoubleMatrix( (N_T[2]*N_T[3]) , 1, mxREAL);
U = mxGetPr(UAray); 
PTempAray = mxCreateDoubleMatrix( (N_T[2]*N_T[3]) , 1, mxREAL);
PTemp = mxGetPr(PTempAray); 


UArayX = mxCreateDoubleMatrix( (N_TX[1]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[1]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 

UArayY = mxCreateDoubleMatrix( (N_TY[1]) , 1, mxREAL);
UY = mxGetPr(UArayY); 
PTempArayY = mxCreateDoubleMatrix( (N_TY[1]) , 1, mxREAL);
PTempY = mxGetPr(PTempArayY); 

BU_OUT = mxCreateNumericArray(KU, NU, mxDOUBLE_CLASS, mxREAL);
//BU_OUT = mxCreateDoubleMatrix(2, N, mxREAL);
BU = mxGetPr(BU_OUT);

BXU_OUT = mxCreateDoubleMatrix(MXU, NXU, mxREAL);
BXU = mxGetPr(BXU_OUT);
// mxCreateDoubleMatrix(M, N, mxREAL); 
BYU_OUT = mxCreateDoubleMatrix(MYU, NYU, mxREAL);
BYU = mxGetPr(BYU_OUT);

// mexPrintf("teta=%f", teta);


// for (W=0; W<50; W++)
while(true)
{
    d1=0;
     d2=0;
     d3=0;
    
    for ( i=1 ; i<N_T[0]; i++)
    {
        for ( j=1; j<N_T[1]; j++)
        {
            for ( act=0; act<N_T[4]; act++)
            {
//                 if (Env[i + (j*N_T[0])]==2)
//                 {
// //                     QU[i + (N_T[0]*(j + (N_T[1]*act)))]=Q[i + (N_T[0]*(j + (N_T[1]*act)))]; // uper bound
//                 }
//                 else
                {
                    maxQ=1;
                     if ( Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))] > 1)
                        maxQ = Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))];
                    TmpC=(pow( (MAXReward_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))]- MINReward_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))]), 2 )) / maxQ;
                     CI_r = sqrt( ((log((2/delta))/2)*TmpC) );
            
                      ctr= -1;
                      Reward=0;
                      q= QU[i + (N_T[0]*(j + (N_T[1]*act)))];
                      for ( ii=0; ii<N_T[2]; ii++)
                            {
                                 for ( jj=0; jj<N_T[3]; jj++)
                                {    
                                   sumQ=0;
                                   maxQ=-1000;
                                   for ( actt=0; actt<N_T[4]; actt++)
                                   {
                                       sumQ=sumQ+QU[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))];
                                       if (maxQ < QU[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))])
                                       {
                                            maxQ=QU[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))];
                                       }
                                    }
                                    if ( (ii==(i-1) && jj==j) || (ii==i && jj==(j+1)) || (ii==(i+1) && jj==j) || (ii==i && jj==(j-1)) || (ii==i && jj==j) )
                                        { 
//                                             mexPrintf("*******  i=%d,    j=%d,    ii=%d,    jj=%d,   act=%d   ********** \n", i, j, ii, jj, act);
                                            ctr = ctr + 1;
                                            U[ctr]=maxQ;
                                            PTemp[ctr] = P[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] ;   
                                        }
                                    Reward=Reward+( P[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] * R[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] ) ; 
                                 }
                             }
                      
                        UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                        U2 = mxGetPr(UAray2); 
                        IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                        Ind = mxGetPr(IndArray); 
                        
//                         const char *fieldNames[] = {"Q", "Ind"}; 
//                         mxArray *UAray2 = mxCreateStructMatrix(ctr, 1, 2, fieldNames);
                        
                        for (ctrp=0; ctrp<=ctr; ctrp++)
                        {
                            U2[ctrp]=U[ctrp];
                            Ind[ctrp]=ctrp;
                        }
                                                
                            for (is = 0; is <= ctr; is ++){
                                for(js = is + 1; js <= ctr; js++){
                                    if(U2[js] > U2[is]){
                                        tempQ = U2[js];
                                        U2[js] = U2[is];
                                        U2[is] = tempQ;
                                        Indtemp = Ind[is];
                                        Ind[is]=Ind[js];
                                        Ind[js]=Indtemp;
                                         tempQ = PTemp[js];
                                        PTemp[js] = PTemp[is];
                                        PTemp[is] = tempQ;
                                    }
                                }
                            }
                        
                             maxQ=1;
                              if ( Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))] > 1)
                                   maxQ = Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))];
                      
                            CI_p = sqrt( (2*(log((( pow( 2, (ctr+1) )) - 2)) - log(delta))) / (maxQ) );   
                            if (ctr==0)
                                CI_p=0;
                              r = Reward + CI_r ; // Upper Bound
                              SumPP = (PTemp[0] + (CI_p/2) );
                              if (SumPP > 1)
                                  SumPP=1;
                              PTemp[0] = SumPP;
                              SumP=0;
                              for (ctrp=0; ctrp<=ctr; ctrp++)
                              {
                                  SumP = SumP + PTemp[ctrp];
                              }
                              
                            ctr2=ctr;
                            while (SumP>1)
                            {
                                SumPP = 1 - (SumP - PTemp[ctr2]);
                                maxQ= SumPP;
                                if (maxQ<0)
                                    maxQ=0;
                                PTemp[ctr2] = maxQ  ;
                                ctr2=ctr2 - 1;
                                SumP=0;
                                  for (ctrp=0; ctrp<=ctr; ctrp++)
                                  {
                                      SumP = SumP + PTemp[ctrp];
                                  }
                            }
                            MMD=0;
                            for (ctrp=0; ctrp<=ctr; ctrp++)
                              {
                                  MMD =MMD + (ga * (U2[ctrp] * PTemp[ctrp]));
                              }
                            MMD =   r + MMD;
                            QU[i +( N_T[0]*(j + (N_T[1]*act)))] = MMD ;  // uper bound
                            BU[i + ( N_T[0]*(j + (N_T[1]*act)))] = MMD ;  // uper bound
                            
//                             mexPrintf("ctr=%d ,   CI_p=%f,  CI_r=%f   \n ", ctr, CI_p, CI_r);

                            
//                                mexPrintf("\n d1=%f, abs=%f, max=%f", d1, fabs(q- MMD), max (d1, fabs(q- MMD)) );
                               maxQ=fabs(q- QU[i +( N_T[0]*(j + (N_T[1]*act)))]);
                               if (d1>maxQ)
                                   maxQ=d1;
                            d1=maxQ;
//                           mexPrintf("************** d1=%f  ,  QU=%f  ***********, CI_r=%f \n", d1, QU[i +( N_T[0]*(j + (N_T[1]*act)))], CI_r);
                    

                    }
            }
        }
    }
//         mexPrintf("teta=%f, d1=%f \n", teta, d1);
      if (d1<teta)
        break;
        
    } // end while


while(true)
{
    d2=0;
    for (ix=0; ix<N_TX[0]; ix++)
    {
        for (actx=0; actx<N_TX[2]; actx++)
        {
            maxQ=1;
            if (Number_X_Action[ix + (N_TX[0]*actx)] > 1)
            {
                maxQ=Number_X_Action[ix + (N_TX[0]*actx)];
            }
            TmpC=pow((MAXReward_X_Action[ix + (N_TX[0]*actx)]- MINReward_X_Action[ix + (N_TX[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QXU[ix + (N_TX[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TX[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TX[2]; acttx++)
               {
                   sumQX=sumQX+QXU[iix+  (N_TX[0]*(acttx))];
                   if (maxQX < QXU[iix+  (N_TX[0]*(acttx))] )
                   {
                        maxQX= QXU[iix+  (N_TX[0]*(acttx))] ;
//                         mexPrintf("QXU= %f, maxQ=%f \n", QXU[iix+  (N_TX[0]*(acttx))], maxQX);
                   }
               }
               if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                    mexPrintf("******* For X:   ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] * RX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_X_Action[ix + (N_TX[0]*actx)] > 1)
            {
                maxQ=Number_X_Action[ix + (N_TX[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] > U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                        tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx + CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ  ;
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gax * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QXU[ix + (N_TX[0]*(actx))] = MMDX ;
            BXU[ix + (N_TX[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QXU[ix + (N_TX[0]*(actx))]);
            if (d2>maxQ)
                maxQ=d2;
            d2=maxQ;
            
//             mexPrintf("************** d2=%f  ,  QUX=%f , CI_r=%f *********** \n", d2, QXU[ix + (N_TX[0]*(actx))], CI_r);
            
        }
    }
    
//             mexPrintf("teta=%f, d2=%f \n", teta, d2);

    if (d2<teta)
        break;
}

while(true)
{
    d3=0;
    for (ix=0; ix<N_TY[0]; ix++)
    {
        for (actx=0; actx<N_TY[2]; actx++)
        {
            maxQ=1;
            if (Number_Y_Action[ix + (N_TY[0]*actx)] > 1)
            {
                maxQ=Number_Y_Action[ix + (N_TY[0]*actx)];
            }
            TmpC=pow((MAXReward_Y_Action[ix + (N_TY[0]*actx)]- MINReward_Y_Action[ix + (N_TY[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QYU[ix + (N_TY[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TY[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TY[2]; acttx++)
               {
                   sumQX=sumQX+QYU[iix+  (N_TY[0]*(acttx))];
                   if (maxQX < QYU[iix+  (N_TY[0]*(acttx))] )
                   {
                        maxQX= QYU[iix+  (N_TY[0]*(acttx))] ;
//                         mexPrintf("QYU= %f, maxQ=%f \n", QYU[iix+  (N_TY[0]*(acttx))], maxQX);
                   }
               }
                if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For Y:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UY[ctr]=maxQX;
                    PTempY[ctr] = PY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] ;
//                     mexPrintf("UY=%f,   PTemp=%f  , maxQX=%f \n",  UY[ctr], PTempY[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] * RY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_Y_Action[ix + (N_TY[0]*actx)] > 1)
            {
                maxQ=Number_Y_Action[ix + (N_TY[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UY[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] > U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempY[js];
                        PTempY[js] = PTempY[is];
                        PTempY[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx + CI_r ; // Upper Bound
              
              SumPP = (PTempY[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempY[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempY[Ind[0]]= %f  , Ind[0]=%f \n",  PTempY[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempY[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempY[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempY[ctr2] = maxQ ;
//                 mexPrintf("PTempY[Ind[ctr2]] =%f \n", PTempY[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempY[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempY[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempY=%f \n", MMDX, U2[ctrp], PTempY[ctrp] );
              }
            MMDX =   r + MMDX;   
            QYU[ix + (N_TY[0]*(actx))] = MMDX ;
            BYU[ix + (N_TY[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QYU[ix + (N_TY[0]*(actx))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUY=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QYU[ix + (N_TY[0]*(actx))], CI_r, CI_p);
            
        }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}




return;
}