#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "matrix.h"
// #define IS REAL 2D FULL DOUBLE(P) (!mxIsComplex(P) && n
// mxGetNumberOfDimensions(P) == 2 && !mxIsSparse(P) && mxIsDouble(P))
// #define IS REAL SCALAR(P) (IS REAL 2D FULL DOUBLE(P) && mxGetNumberOfElements(P) == 1)
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
#define B_OUT plhs[0]
#define BX_OUT plhs[1]
#define BY_OUT plhs[2]
#define Q2 prhs[0]
#define Trns_S2NS_Action prhs[1]
#define Reward_S_Action prhs[2]
#define epsilon prhs[3]
#define gama prhs[4]
#define epi prhs[5]
#define Q2X prhs[6]
#define Q2Y prhs[7]
#define Trns_X2NX_Action prhs[8]
#define Reward_X_Action prhs[9]
#define Trns_Y2NY_Action prhs[10]
#define Reward_Y_Action prhs[11]
#define gamax prhs[12]
#define gamay prhs[13]
#define Environment prhs[14]
    
    
size_t K = mxGetNumberOfDimensions(Q2);
const mwSize *N = mxGetDimensions(Q2);
double *Q = mxGetPr(Q2);
double *QX = mxGetPr(Q2X);
double *QY = mxGetPr(Q2Y);
int MX = mxGetM(Q2X); /* Get the dimensions of A */
int NX = mxGetN(Q2X);

int MY = mxGetM(Q2Y); /* Get the dimensions of A */
int NY = mxGetN(Q2Y);

size_t K_T = mxGetNumberOfDimensions(Trns_S2NS_Action);
const mwSize *N_T = mxGetDimensions(Trns_S2NS_Action);
double *P = mxGetPr(Trns_S2NS_Action);
double *R = mxGetPr(Reward_S_Action);
size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);
size_t K_TY = mxGetNumberOfDimensions(Trns_Y2NY_Action);
const mwSize *N_TY = mxGetDimensions(Trns_Y2NY_Action);
double *PY = mxGetPr(Trns_Y2NY_Action);
double *RY = mxGetPr(Reward_Y_Action);


double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double *Env = mxGetPr(Environment);
//double teta = mxGetScalar(theta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *B, *BX, *BY;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double QN; 
  
int ix, iy,iix, actx, acty, acttx;
double qx, MMDX, QNX, sumQX, maxQX;

B_OUT = mxCreateNumericArray(K, N, mxDOUBLE_CLASS, mxREAL);
//B_OUT = mxCreateDoubleMatrix(2, N, mxREAL);
B = mxGetPr(B_OUT);

BX_OUT = mxCreateDoubleMatrix(MX, NX, mxREAL);
BX = mxGetPr(BX_OUT);
// mxCreateDoubleMatrix(M, N, mxREAL); 
BY_OUT = mxCreateDoubleMatrix(MY, NY, mxREAL);
BY = mxGetPr(BY_OUT);


// A = mxGetPr(A_IN); /* Get the pointer to the data of A */
//B OUT = mxCreateDoubleMatrix(M, N, mxREAL); /* Create the output matrix */

while (true)
{
    d1=0;
     d2=0;
     d3=0;
    
    for ( i=1 ; i<N_T[0]; i++)
    {
        for ( j=1; j<N_T[1]; j++)
        {
            for ( act=0; act< N_T[4]; act++)
            {
                
//                   if (Env[i + (j*N_T[0])]==2)
//                 {
// //                     QU[i + (N_T[0]*(j + (N_T[1]*act)))]=Q[i + (N_T[0]*(j + (N_T[1]*act)))]; // uper bound
//                 }
//                 else
                {
                   q=Q[i + (N_T[0]*(j + (N_T[1]*act)))];
                   MMD=0;
                  
                  for ( ii=0; ii<N_T[2]; ii++)
                  {
                      for ( jj=0; jj<N_T[3]; jj++)
                      {                           
                            sumQ=0;
                            maxQ=-1000;
                           for ( actt=0; actt<N_T[4]; actt++)
                           {
                               sumQ=sumQ+Q[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))];
                               if (maxQ < Q[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))])
                               {
                                    maxQ=Q[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))];
                               }
                           }
                          
                          QN = ((1-eps)* maxQ) + ((eps/N_T[4])* (sumQ));
                          MMD=MMD+( P[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] *( R[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))]  + (ga*QN)) );
                                 // Trns_S2NS_Action(i + j*( (Length+1)) + ii*( (Length+1)*(Length+1)) + jj*((Length+1)*(Length+1)*(Length+2)) + act*((Length+1)*(Length+1)*(Length+2)*(Length+2)) )*Reward_S_Action(i ,j, :, :, act);
                      }
                  }
                  
                  Q[i +( (N_T[0])*(j + (N_T[1]*act)))] = MMD ;
                  B[i + ( (N_T[0])*(j + (N_T[1]*act)))] = MMD ;
                  
                   if (fabs(q- MMD) > d1)
                       d1=fabs(q- MMD);
//                   d1=max (d1, fabs(q- MMD)) ;
                  
                  
                  //Trns=reshape(Trns_S2NS_Action(i ,j, :, :, act), size(Trns_S2NS_Action, 3), size(Trns_S2NS_Action, 4));
                  // reward = reshape(Reward_S_Action(i ,j, :, :, act), size(Reward_S_Action, 3), size(Reward_S_Action, 4));
                  //QN= (1-epsilon).* reshape(max(Q2(:, :,:), [], 3), size(Q2, 1), size(Q2, 2)) + (epsilon/NumAction).* (sum(Q2(:, :, :), 3));
                  // MMD= sum(sum(Trns.* (reward + gama*QN))); 
                  //Q2(i ,j,act) = MMD ;
                 // d1=max (d1, fabs(q- Q2(i, j , act))) ;
                }
            }
        }
    }
     

for (ix=0; ix<N_TX[0]; ix++)
    {
        for (actx=0; actx<N_TX[2]; actx++)
        {
            qx=QX[ix + (N_TX[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TX[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TX[2]; acttx++)
               {
                   sumQX=sumQX+QX[iix+  (N_TX[0]*(acttx))];
                   if (maxQX < QX[iix+  (N_TX[0]*(acttx))] )
                   {
                        maxQX= QX[iix+  (N_TX[0]*(acttx))] ;
                   }
               }

              QNX = ((1-eps)* maxQX) + ((eps/N_TX[2])* (sumQX));
              MMDX=MMDX+( PX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] *( RX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] + (gax*QNX)) );
                     // Trns_S2NS_Action(i + j*( (Length+1)) + ii*( (Length+1)*(Length+1)) + jj*((Length+1)*(Length+1)*(Length+2)) + act*((Length+1)*(Length+1)*(Length+2)*(Length+2)) )*Reward_S_Action(i ,j, :, :, act);
          }
          QX[ix + (N_TX[0]*(actx))] = MMDX ;
          BX[ix + (N_TX[0]*(actx))] = MMDX ;
          
          if ( fabs(qx- MMDX) > d2 )
              d2=fabs(qx- MMDX);
          
//           d2=max (d2, fabs(qx- MMDX)) ;
        }
    }



    for (ix=0; ix<N_TY[0]; ix++)
    {
         for (actx=0; actx<N_TY[2]; actx++)
        {
            qx=QY[ix + (N_TY[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TY[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TY[2]; acttx++)
               {
                   sumQX=sumQX+QY[iix+  (N_TY[0]*(acttx))];
                   if (maxQX < QY[iix+  (N_TY[0]*(acttx))] )
                   {
                        maxQX= QY[iix+  (N_TY[0]*(acttx))] ;
                   }
               }

              QNX = ((1-eps)* maxQX) + ((eps/N_TY[2])* (sumQX));
              MMDX=MMDX+( PY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] *( RY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] + (gay*QNX)) );
                     // Trns_S2NS_Action(i + j*( (Length+1)) + ii*( (Length+1)*(Length+1)) + jj*((Length+1)*(Length+1)*(Length+2)) + act*((Length+1)*(Length+1)*(Length+2)*(Length+2)) )*Reward_S_Action(i ,j, :, :, act);
          }
          QY[ix + (N_TY[0]*(actx))] = MMDX ;
          BY[ix + (N_TY[0]*(actx))] = MMDX ;
          
          if ( fabs(qx- MMDX) > d3 )
                  d3 = fabs(qx- MMDX);
          
//           d3=max (d3, fabs(qx- MMDX)) ;
        }
    } 
    
      if (d1<teta && d2<teta && d3<teta )
        break;
 
}
   return;     
}         



/* for act=1 : NumAction
             % for X
              qx=Q2X(i, act) ;
              Trnsx=reshape(Trns_X2NX_Action(i , :, act), size(Trns_X2NX_Action, 2), 1);
              rewardx = reshape(Reward_X_Action(i , :, act), size(Reward_X_Action, 2), 1);
              QN = (1-epsilon).* (max(Q2X(:,:), [], 2)) + (epsilon/NumAction).* (sum(Q2X(:,:), 2));
              MMD = sum((Trnsx.* (rewardx + gama_s*QN))); 
              Q2X(i ,act) = MMD ;
              d2=max (d2, abs(qx- Q2X(i, act))) ;

               % for Y
              qy=Q2Y(i, act) ;
              Trnsy=reshape(Trns_Y2NY_Action(i , :, act), size(Trns_Y2NY_Action, 2), 1);
              rewardy= reshape(Reward_Y_Action(i , :, act), size(Reward_Y_Action, 2), 1);
              QN= (1-epsilon).* (max(Q2Y(:,:), [], 2)) + (epsilon/NumAction).* (sum(Q2Y(:,:), 2));
              MMD= sum((Trnsy.* (rewardy + gama_s*QN))); 
              Q2Y(i ,act) = MMD ;
              d3=max (d3, abs(qy- Q2Y(i, act))) ;
         end
    end

  if (d1<teta && d2<teta && d3<teta )
        break
}




function [Q2, Q2X, Q2Y]=ValueIterationBD_sub(Q2, Q2X, Q2Y, epsilon, ep)

global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD gama_s
global MaxStep num_episode num_runs numAction Length LL P_C landa
global  Q_UCRL Q_LCRL
global Array_CI_p M_Array m_Array D_Array ChooseSpace
global Q_X Q_Y Q_XL Q_YL Q_XU Q_YU
global DD1 DD2 DD3
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action Reward_X_Action Reward_Y_Action
global NumAction
%   Detailed explanation goes here

 teta=0.01/(log10(ep+9));

    
end
 */

