global aveRewardArraySMB aveRewardArrayS aveRewardArraySP aveRewardArraySQL WeightEGS aveRewardArraySLA

% save('Mix.mat')
[h, p, ci, INF]=ttest2(aveRewardArraySMB, aveRewardArrayS, 'tail', 'both', 'vartype', 'unequal', 'Alpha',0.05);
[h2, p2, ci2, INF2]=ttest2(aveRewardArraySQL, aveRewardArraySP, 'tail', 'both', 'vartype', 'unequal', 'Alpha',0.05);
[h3, p3, ci3, INF3]=ttest2(aveRewardArraySLA, aveRewardArraySQL, 'tail', 'left', 'vartype', 'unequal', 'Alpha',0.05);
V1=sqrt(var(aveRewardArrayS))./sqrt(10);
V2=sqrt(var(aveRewardArraySMB))./sqrt(10);
V3=sqrt(var(aveRewardArraySQL))./sqrt(10);
V4=sqrt(var(aveRewardArraySP))./sqrt(10);
V5=sqrt(var(aveRewardArraySLA))./sqrt(10);



ind=find(h==1);
xmarkers =ind; % place markers at these x-values
ymarkers = mean(aveRewardArraySMB(:, ind));
% plot(xmarkers,ymarkers,'r*');
% plot(mean(aveRewardArrayMB), 'b');


figure;
hold on
grid on
% set(gca, 'fontsize', 16)
subplot(1, 2, 1); plot(mean(aveRewardArrayS),  'r' ,'LineWidth',4)
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArraySMB),'b-.','LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySQL),  'k: ' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySP),  'g--' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySLA),  'm' ,'LineWidth',4)
set(gca, 'fontsize', 12, 'FontWeight','bold')
legend('MoBLeS', 'MB', 'Q(\lambda)', 'QS(\lambda)', 'QL', 'FontSize', 16, 'FontWeight','bold');
xlabel('#episode', 'FontSize', 16,'FontWeight', 'bold')
ylabel('Average accumulated reward', 'FontSize', 16, 'FontWeight','bold')

% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArrayS(:, [1,10,20,30,40,50,60,70,80,90])), INF.sd(2, [1,10,20,30,40,50,60,70,80,90] ),  '.r')
% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArraySMB(:, [1,10,20,30,40,50,60,70,80,90])), INF.sd(1,[1,10,20,30,40,50,60,70,80,90] ) ,'.b')
% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArraySQL( :, [1,10,20,30,40,50,60,70,80,90])), INF2.sd(1, [1,10,20,30,40,50,60,70,80,90] ),  '.k')
% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArraySP( :, [1,10,20,30,40,50,60,70,80,90])),  INF2.sd(2, [1,10,20,30,40,50,60,70,80,90] ),  '.g')

subplot(1, 2, 1); errorbar([5,15,25,35,45,55,65,75,85,95] , mean(aveRewardArrayS(:, [5,15,25,35,45,55,65,75,85,95] )), INF.sd(2, [5,15,25,35,45,55,65,75,85,95] ),  '.r')
subplot(1, 2, 1); errorbar( [5,15,25,35,45,55,65,75,85,95] , mean(aveRewardArraySMB(:,  [5,15,25,35,45,55,65,75,85,95] )), INF.sd(1, [5,15,25,35,45,55,65,75,85,95] ) ,'.b')
subplot(1, 2, 1); errorbar( [5,15,25,35,45,55,65,75,85,95] , mean(aveRewardArraySQL( :, [5,15,25,35,45,55,65,75,85,95] )), INF2.sd(1, [5,15,25,35,45,55,65,75,85,95] ),  '.k')
subplot(1, 2, 1); errorbar( [5,15,25,35,45,55,65,75,85,95] , mean(aveRewardArraySP( :,  [5,15,25,35,45,55,65,75,85,95] )),  INF2.sd(2, [5,15,25,35,45,55,65,75,85,95] ),  '.g')
subplot(1, 2, 1); errorbar( [5,15,25,35,45,55,65,75,85,95] , mean(aveRewardArraySLA( :,  [5,15,25,35,45,55,65,75,85,95] )),  INF3.sd(1, [5,15,25,35,45,55,65,75,85,95] ),  '.m')
% axis([0 100 -200 -40]);

for i=1: size(WeightEGS, 1)
    WeightEGSN(i, :, :) = WeightEGS(i, :, :) ./ sum(WeightEGS, 1);
    WeightEGSS(i, :) = smooth(mean(WeightEGSN(i, :, :), 3), 5);
end
subplot(1, 2, 2); plot(WeightEGSS(1,:)','b-.','LineWidth',2);
hold on
subplot(1, 2, 2); plot(WeightEGSS(2,:)','g--','LineWidth',2);
subplot(1, 2, 2); plot(WeightEGSS(3,:)','r','LineWidth',2);
set(gca, 'fontsize', 12, 'FontWeight','bold')
legend('Subspace y', 'Subspace x', 'Joint space', 'FontSize', 16, 'bold')
grid on
xlabel('#episode', 'FontSize', 16, 'FontWeight','bold');
ylabel('Normalized wieght of each space', 'FontSize', 16, 'FontWeight','bold');
axis([0 100 0 1]);
   


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure;
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArrayS),  'r' ,'LineWidth',4)
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArraySMB),'b-.','LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySQL),  'k: ' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySP),  'g--' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySLA),  'm' ,'LineWidth',4)
set(gca, 'fontsize', 12, 'FontWeight','bold')
legend('MoBLeS', 'MB', 'Q(\lambda)', 'QS(\lambda)', 'QL', 'FontSize', 16, 'FontWeight','bold');
xlabel('#episode', 'FontSize', 16, 'FontWeight','bold')
ylabel('Average accumulated reward', 'FontSize', 16, 'FontWeight','bold')

subplot(1, 2, 1);
hold on
varargout2= shadedErrorBar(1:size(aveRewardArraySQL, 2),mean(aveRewardArraySQL), V3, 'k:', 1);
varargout3= shadedErrorBar(1:size(aveRewardArraySP, 2),mean(aveRewardArraySP), V4, 'g--', 1);
varargout1= shadedErrorBar(1:size(aveRewardArraySMB, 2),mean(aveRewardArraySMB), V2, 'b-.', 1);
varargout4= shadedErrorBar(1:size(aveRewardArrayS, 2), mean(aveRewardArrayS), V1, 'r', 1);
varargout5= shadedErrorBar(1:size(aveRewardArraySLA, 2),mean(aveRewardArraySLA), V5, 'm', 1);
% varargout6= shadedErrorBar(1:size(aveRewardArrayQLZ, 2),mean(aveRewardArrayQLZ), INF3.sd(2, :), 'k:', 1);


ind=find(h==1);
xmarkers =ind; % place markers at these x-values
ymarkers = mean(aveRewardArrayS(: ,ind));

% subplot(1, 2, 1); plot(xmarkers,ymarkers,'r *', 'LineWidth',1);


subplot(1, 2, 1);plot(mean(aveRewardArrayS),  'r' ,'LineWidth',4)
hold on
subplot(1, 2, 1); plot(mean(aveRewardArraySMB),'b-.','LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySQL),  'k: ' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySP),  'g--' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySLA),  'm' ,'LineWidth',4)
% axis([0 100 -200 -40]);


% plot(xmarkers,ymarkers,'r*');


% %%%%%%%%%%%%%%%%%%%%5
% Weight
for i=1: size(WeightEGS, 1)
    WeightEGSN(i, :, :) = WeightEGS(i, :, :) ./ sum(WeightEGS, 1);
    WeightEGSS(i, :) = smooth(mean(WeightEGSN(i, :, :), 3), 5);
end
subplot(1, 2, 2); plot(WeightEGSS(1,:)','b-.','LineWidth',2);
hold on
subplot(1, 2, 2); plot(WeightEGSS(2,:)','g--','LineWidth',2);
subplot(1, 2, 2); plot(WeightEGSS(3,:)','r','LineWidth',2);
set(gca, 'fontsize', 12, 'FontWeight','bold')
legend('Subspace y', 'Subspace x', 'Joint space', 'FontSize', 16, 'FontWeight','bold')
grid on

xlabel('#episode', 'FontSize', 16, 'FontWeight','bold');
ylabel('Normalized wieght of each space', 'FontSize', 16, 'FontWeight','bold');
axis([0 100 0 1]);






