#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
#define BU_OUT plhs[0]
// #define BXYU_OUT plhs[1]
// #define BXIU_OUT plhs[2]
// #define BYIU_OUT plhs[3]
#define BXU_OUT plhs[1]
#define BYU_OUT plhs[2]
#define BIU_OUT plhs[3]
#define BIrU_OUT plhs[4]
#define BIdU_OUT plhs[5]
#define BIlU_OUT plhs[6]
    
#define Trns_S2NS_Action prhs[0]
// #define Trns_XY2NXY_Action prhs[1]
// #define Trns_XI2NXI_Action prhs[2]
// #define Trns_YI2NYI_Action prhs[3]
#define Trns_X2NX_Action prhs[1]
#define Trns_Y2NY_Action prhs[2]
#define Trns_I2NI_Action prhs[3]
#define Trns_Ir2NIr_Action prhs[4]
#define Trns_Id2NId_Action prhs[5]
#define Trns_Il2NIl_Action prhs[6]
    
#define Reward_S_Action prhs[7]
// #define Reward_XY_Action prhs[8]
// #define Reward_XI_Action prhs[9]
// #define Reward_YI_Action prhs[10]
#define Reward_X_Action prhs[8]
#define Reward_Y_Action prhs[9]
#define Reward_I_Action prhs[10]
#define Reward_Ir_Action prhs[11]
#define Reward_Id_Action prhs[12]
#define Reward_Il_Action prhs[13]
    
#define NumberSA prhs[14]
// #define NumberXYA prhs[15]
// #define NumberXIA prhs[16]
// #define NumberYIA prhs[17]
#define NumberXA prhs[15]
#define NumberYA prhs[16]
#define NumberIA prhs[17]
#define NumberIrA prhs[18]
#define NumberIdA prhs[19]
#define NumberIlA prhs[20]
    
#define Q2U prhs[21]
// #define Q2UXY prhs[22]
// #define Q2UXI prhs[23]
// #define Q2UYI prhs[24]
#define Q2UX prhs[22]
#define Q2UY prhs[23]
#define Q2UI prhs[24]
#define Q2UIr prhs[25]
#define Q2UId prhs[26]
#define Q2UIl prhs[27]

#define MINRewardSA prhs[28]
#define MAXRewardSA prhs[29]
// #define MINRewardXYA prhs[30]
// #define MAXRewardXYA prhs[31]
// #define MINRewardXIA prhs[32]
// #define MAXRewardXIA prhs[33]
// #define MINRewardYIA prhs[34]
// #define MAXRewardYIA prhs[35]
#define MINRewardXA prhs[30]
#define MAXRewardXA prhs[31]
#define MINRewardYA prhs[32]
#define MAXRewardYA prhs[33]
#define MINRewardIA prhs[34]
#define MAXRewardIA prhs[35]
#define MINRewardIrA prhs[36]
#define MAXRewardIrA prhs[37]
#define MINRewardIdA prhs[38]
#define MAXRewardIdA prhs[39]
#define MINRewardIlA prhs[40]
#define MAXRewardIlA prhs[41]

#define epsilon prhs[42]
#define gama prhs[43]
#define gamax prhs[44]
#define gamay prhs[45]
#define epi prhs[46]
#define Environment prhs[47]   
#define Delta prhs[48]    
    
#define Q2X prhs[49]
#define Q2Y prhs[50]
#define Q2 prhs[51]
#define Q2I prhs[52]
#define Q2Ir prhs[53]
#define Q2Id prhs[54]
#define Q2Il prhs[55]

       
size_t K = mxGetNumberOfDimensions(Q2);
const mwSize *N = mxGetDimensions(Q2);
double *Q = mxGetPr(Q2);
double *QX = mxGetPr(Q2X);
double *QY = mxGetPr(Q2Y);
int MX = mxGetM(Q2X); /* Get the dimensions of A */
int NX = mxGetN(Q2X);
int MY = mxGetM(Q2Y); /* Get the dimensions of A */
int NY = mxGetN(Q2Y);

int W=0;

double *QU = mxGetPr(Q2U);
// double *QUXY = mxGetPr(Q2UXY);
// double *QUXI = mxGetPr(Q2UXI);
// double *QUYI = mxGetPr(Q2UYI);
double *QXU = mxGetPr(Q2UX);
double *QYU = mxGetPr(Q2UY);
double *QIU = mxGetPr(Q2UI);
double *QIrU = mxGetPr(Q2UIr);
double *QIdU = mxGetPr(Q2UId);
double *QIlU = mxGetPr(Q2UIl);

int MXU = mxGetM(Q2UX); /* Get the dimensions of A */
int NXU = mxGetN(Q2UX);
int MYU = mxGetM(Q2UY); /* Get the dimensions of A */
int NYU = mxGetN(Q2UY);
int MIU = mxGetM(Q2UI); /* Get the dimensions of A */
int NIU = mxGetN(Q2UI);

int MIrU = mxGetM(Q2UIr); /* Get the dimensions of A */
int NIrU = mxGetN(Q2UIr);

int MIdU = mxGetM(Q2UId); /* Get the dimensions of A */
int NIdU = mxGetN(Q2UId);

int MIlU = mxGetM(Q2UIl); /* Get the dimensions of A */
int NIlU = mxGetN(Q2UIl);

size_t KU = mxGetNumberOfDimensions(Q2U);
const mwSize *NU = mxGetDimensions(Q2U);

// size_t KUXY = mxGetNumberOfDimensions(Q2UXY);
// const mwSize *NUXY = mxGetDimensions(Q2UXY);
// 
// size_t KUXI = mxGetNumberOfDimensions(Q2UXI);
// const mwSize *NUXI = mxGetDimensions(Q2UXI);
// 
// size_t KUYI = mxGetNumberOfDimensions(Q2UYI);
// const mwSize *NUYI = mxGetDimensions(Q2UYI);

double *Number_S_Action = mxGetPr(NumberSA);
// double *Number_XY_Action = mxGetPr(NumberXYA);
// double *Number_XI_Action = mxGetPr(NumberXIA);
// double *Number_YI_Action = mxGetPr(NumberYIA);
double *Number_X_Action = mxGetPr(NumberXA);
double *Number_Y_Action = mxGetPr(NumberYA);
double *Number_I_Action = mxGetPr(NumberIA);
double *Number_Ir_Action = mxGetPr(NumberIrA);
double *Number_Id_Action = mxGetPr(NumberIdA);
double *Number_Il_Action = mxGetPr(NumberIlA);

double *MINReward_S_Action = mxGetPr(MINRewardSA);
// double *MINReward_XY_Action = mxGetPr(MINRewardXYA);
// double *MINReward_XI_Action = mxGetPr(MINRewardXIA);
// double *MINReward_YI_Action = mxGetPr(MINRewardYIA);
double *MINReward_X_Action = mxGetPr(MINRewardXA);
double *MINReward_Y_Action = mxGetPr(MINRewardYA);
double *MINReward_I_Action = mxGetPr(MINRewardIA);
double *MINReward_Ir_Action = mxGetPr(MINRewardIrA);
double *MINReward_Id_Action = mxGetPr(MINRewardIdA);
double *MINReward_Il_Action = mxGetPr(MINRewardIlA);

double *MAXReward_S_Action = mxGetPr(MAXRewardSA);
// double *MAXReward_XY_Action = mxGetPr(MAXRewardXYA);
// double *MAXReward_XI_Action = mxGetPr(MAXRewardXIA);
// double *MAXReward_YI_Action = mxGetPr(MAXRewardYIA);
double *MAXReward_X_Action = mxGetPr(MAXRewardXA);
double *MAXReward_Y_Action = mxGetPr(MAXRewardYA);
double *MAXReward_I_Action = mxGetPr(MAXRewardIA);
double *MAXReward_Ir_Action = mxGetPr(MAXRewardIrA);
double *MAXReward_Id_Action = mxGetPr(MAXRewardIdA);
double *MAXReward_Il_Action = mxGetPr(MAXRewardIlA);

size_t K_T = mxGetNumberOfDimensions(Trns_S2NS_Action);
const mwSize *N_T = mxGetDimensions(Trns_S2NS_Action);
double *P = mxGetPr(Trns_S2NS_Action);
double *R = mxGetPr(Reward_S_Action);

// size_t K_TXY = mxGetNumberOfDimensions(Trns_XY2NXY_Action);
// const mwSize *N_TXY = mxGetDimensions(Trns_XY2NXY_Action);
// double *PXY = mxGetPr(Trns_XY2NXY_Action);
// double *RXY = mxGetPr(Reward_XY_Action);
// 
// size_t K_TXI = mxGetNumberOfDimensions(Trns_XI2NXI_Action);
// const mwSize *N_TXI = mxGetDimensions(Trns_XI2NXI_Action);
// double *PXI = mxGetPr(Trns_XI2NXI_Action);
// double *RXI = mxGetPr(Reward_XI_Action);
// 
// size_t K_TYI = mxGetNumberOfDimensions(Trns_YI2NYI_Action);
// const mwSize *N_TYI = mxGetDimensions(Trns_YI2NYI_Action);
// double *PYI = mxGetPr(Trns_YI2NYI_Action);
// double *RYI = mxGetPr(Reward_YI_Action);

size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);
size_t K_TY = mxGetNumberOfDimensions(Trns_Y2NY_Action);
const mwSize *N_TY = mxGetDimensions(Trns_Y2NY_Action);
double *PY = mxGetPr(Trns_Y2NY_Action);
double *RY = mxGetPr(Reward_Y_Action);
size_t K_TI = mxGetNumberOfDimensions(Trns_I2NI_Action);
const mwSize *N_TI = mxGetDimensions(Trns_I2NI_Action);
double *PI = mxGetPr(Trns_I2NI_Action);
double *RI = mxGetPr(Reward_I_Action);

size_t K_TIr = mxGetNumberOfDimensions(Trns_Ir2NIr_Action);
const mwSize *N_TIr = mxGetDimensions(Trns_Ir2NIr_Action);
double *PIr = mxGetPr(Trns_Ir2NIr_Action);
double *RIr = mxGetPr(Reward_Ir_Action);

size_t K_TId = mxGetNumberOfDimensions(Trns_Id2NId_Action);
const mwSize *N_TId = mxGetDimensions(Trns_Id2NId_Action);
double *PId = mxGetPr(Trns_Id2NId_Action);
double *RId = mxGetPr(Reward_Id_Action);

size_t K_TIl = mxGetNumberOfDimensions(Trns_Il2NIl_Action);
const mwSize *N_TIl = mxGetDimensions(Trns_Il2NIl_Action);
double *PIl = mxGetPr(Trns_Il2NIl_Action);
double *RIl = mxGetPr(Reward_Il_Action);

// int MEnv = mxGetM(Environment); /* Get the dimensions of A */
// int NEnv = mxGetN(Environment);
double *Env = mxGetPr(Environment);
double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *BU, *BXU, *BYU, *BIU, *BIrU, *BIdU,*BIlU, *BXYU, *BXIU, *BYIU;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
  
int ix,iix, actx, acttx;
double  sumQX, maxQX;


mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;

UAray = mxCreateDoubleMatrix( (N_T[2]*N_T[3]) , 1, mxREAL);
U = mxGetPr(UAray); 
PTempAray = mxCreateDoubleMatrix( (N_T[2]*N_T[3]) , 1, mxREAL);
PTemp = mxGetPr(PTempAray); 


UArayX = mxCreateDoubleMatrix( (N_TX[1]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[1]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 

UArayY = mxCreateDoubleMatrix( (N_TY[1]) , 1, mxREAL);
UY = mxGetPr(UArayY); 
PTempArayY = mxCreateDoubleMatrix( (N_TY[1]) , 1, mxREAL);
PTempY = mxGetPr(PTempArayY); 

BU_OUT = mxCreateNumericArray(KU, NU, mxDOUBLE_CLASS, mxREAL);
BU = mxGetPr(BU_OUT);

// BXYU_OUT = mxCreateNumericArray(KUXY, NUXY, mxDOUBLE_CLASS, mxREAL);
// BXYU = mxGetPr(BXYU_OUT);
// 
// BXIU_OUT = mxCreateNumericArray(KUXI, NUXI, mxDOUBLE_CLASS, mxREAL);
// BXIU = mxGetPr(BXIU_OUT);
// 
// BYIU_OUT = mxCreateNumericArray(KUYI, NUYI, mxDOUBLE_CLASS, mxREAL);
// BYIU = mxGetPr(BYIU_OUT);

BXU_OUT = mxCreateDoubleMatrix(MXU, NXU, mxREAL);
BXU = mxGetPr(BXU_OUT);
 
BYU_OUT = mxCreateDoubleMatrix(MYU, NYU, mxREAL);
BYU = mxGetPr(BYU_OUT);

BIU_OUT = mxCreateDoubleMatrix(MIU, NIU, mxREAL);
BIU = mxGetPr(BIU_OUT);

BIrU_OUT = mxCreateDoubleMatrix(MIrU, NIrU, mxREAL);
BIrU = mxGetPr(BIrU_OUT);

BIdU_OUT = mxCreateDoubleMatrix(MIdU, NIdU, mxREAL);
BIdU = mxGetPr(BIdU_OUT);

BIlU_OUT = mxCreateDoubleMatrix(MIlU, NIlU, mxREAL);
BIlU = mxGetPr(BIlU_OUT);

// mexPrintf("teta=%f", teta);


// for (W=0; W<50; W++)
while(true)
{
    d1=0;
     d2=0;
     d3=0;
    
    for ( i=1 ; i<N_T[0]; i++)
    {
        for ( j=1; j<N_T[1]; j++)
        {
            for ( act=0; act<N_T[4]; act++)
            {
//                 if (Env[i + (j*N_T[0])]==2)
//                 {
// //                     QU[i + (N_T[0]*(j + (N_T[1]*act)))]=Q[i + (N_T[0]*(j + (N_T[1]*act)))]; // uper bound
//                 }
//                 else
                {
//                 Number_S_Action MAXReward_S_Action MINReward_S_Action N_T QU
                    maxQ=1;
                     if ( Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))] > 1)
                        maxQ = Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))];
                    TmpC=(pow( (MAXReward_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))]- MINReward_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))]), 2 )) / maxQ;
                     CI_r = sqrt( ((log((2/delta))/2)*TmpC) );
            
                      ctr= -1;
                      Reward=0;
                      q= QU[i + (N_T[0]*(j + (N_T[1]*act)))];
                      for ( ii=0; ii<N_T[2]; ii++)
                            {
                                 for ( jj=0; jj<N_T[3]; jj++)
                                {    
                                   sumQ=0;
                                   maxQ=-1000;
                                   for ( actt=0; actt<N_T[4]; actt++)
                                   {
                                       sumQ=sumQ+QU[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))];
                                       if (maxQ < QU[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))])
                                       {
                                            maxQ=QU[ii+  (N_T[2]*(jj+  (N_T[3]*actt)))];
                                       }
                                    }
                                    if ( (ii==(i-1) && jj==j) || (ii==i && jj==(j+1)) || (ii==(i+1) && jj==j) || (ii==i && jj==(j-1)) || (ii==i && jj==j) )
                                        { 
//                                             mexPrintf("*******  i=%d,    j=%d,    ii=%d,    jj=%d,   act=%d   ********** \n", i, j, ii, jj, act);
                                            ctr = ctr + 1;
                                            U[ctr]=maxQ;
                                            PTemp[ctr] = P[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] ;   
                                        }
                                    Reward=Reward+( P[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] * R[i+ (N_T[0]*(j +( N_T[1]*(ii+  (N_T[2]*(jj+  (N_T[3]*act)))))))] ) ; 
                                 }
                             }
                      
                        UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                        U2 = mxGetPr(UAray2); 
                        IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                        Ind = mxGetPr(IndArray); 
                        
//                         const char *fieldNames[] = {"Q", "Ind"}; 
//                         mxArray *UAray2 = mxCreateStructMatrix(ctr, 1, 2, fieldNames);
                        
                        for (ctrp=0; ctrp<=ctr; ctrp++)
                        {
                            U2[ctrp]=U[ctrp];
                            Ind[ctrp]=ctrp;
                        }
                                                
                            for (is = 0; is <= ctr; is ++){
                                for(js = is + 1; js <= ctr; js++){
                                    if(U2[js] < U2[is]){
                                        tempQ = U2[js];
                                        U2[js] = U2[is];
                                        U2[is] = tempQ;
                                        Indtemp = Ind[is];
                                        Ind[is]=Ind[js];
                                        Ind[js]=Indtemp;
                                         tempQ = PTemp[js];
                                        PTemp[js] = PTemp[is];
                                        PTemp[is] = tempQ;
                                    }
                                }
                            }
                        
                             maxQ=1;
                              if ( Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))] > 1)
                                   maxQ = Number_S_Action[i + (N_T[0]*(j + (N_T[1]*act)))];
                      
                            CI_p = sqrt( (2*(log((( pow( 2, (ctr+1) )) - 2)) - log(delta))) / (maxQ) );   
                            if (ctr==0)
                                CI_p=0;
                              r = Reward - CI_r ; // Upper Bound
                              SumPP = (PTemp[0] + (CI_p/2) );
                              if (SumPP > 1)
                                  SumPP=1;
                              PTemp[0] = SumPP;
                              SumP=0;
                              for (ctrp=0; ctrp<=ctr; ctrp++)
                              {
                                  SumP = SumP + PTemp[ctrp];
                              }
                              
                            ctr2=ctr;
                            while (SumP>1)
                            {
                                SumPP = 1 - (SumP - PTemp[ctr2]);
                                maxQ= SumPP;
                                if (maxQ<0)
                                    maxQ=0;
                                PTemp[ctr2] = maxQ  ;
                                ctr2=ctr2 - 1;
                                SumP=0;
                                  for (ctrp=0; ctrp<=ctr; ctrp++)
                                  {
                                      SumP = SumP + PTemp[ctrp];
                                  }
                            }
                            MMD=0;
                            for (ctrp=0; ctrp<=ctr; ctrp++)
                              {
                                  MMD =MMD + (ga * (U2[ctrp] * PTemp[ctrp]));
                              }
                            MMD =   r + MMD;
                            QU[i +( N_T[0]*(j + (N_T[1]*act)))] = MMD ;  // uper bound
                            BU[i + ( N_T[0]*(j + (N_T[1]*act)))] = MMD ;  // uper bound
                            
//                             mexPrintf("ctr=%d ,   CI_p=%f,  CI_r=%f   \n ", ctr, CI_p, CI_r);

                            
//                                mexPrintf("\n d1=%f, abs=%f, max=%f", d1, fabs(q- MMD), max (d1, fabs(q- MMD)) );
                               maxQ=fabs(q- QU[i +( N_T[0]*(j + (N_T[1]*act)))]);
                               if (d1>maxQ)
                                   maxQ=d1;
                            d1=maxQ;
//                           mexPrintf("************** d1=%f  ,  QU=%f  ***********, CI_r=%f \n", d1, QU[i +( N_T[0]*(j + (N_T[1]*act)))], CI_r);
                    

                    }
            }
        }
    }
//         mexPrintf("teta=%f, d1=%f \n", teta, d1);
      if (d1<teta)
        break;
        
    } // end while


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// *********** FOR X
while(true)
{
    d2=0;
    for (ix=0; ix<N_TX[0]; ix++)
    {
        for (actx=0; actx<N_TX[2]; actx++)
        {
            maxQ=1;
            if (Number_X_Action[ix + (N_TX[0]*actx)] > 1)
            {
                maxQ=Number_X_Action[ix + (N_TX[0]*actx)];
            }
            TmpC=pow((MAXReward_X_Action[ix + (N_TX[0]*actx)]- MINReward_X_Action[ix + (N_TX[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QXU[ix + (N_TX[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TX[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TX[2]; acttx++)
               {
                   sumQX=sumQX+QXU[iix+  (N_TX[0]*(acttx))];
                   if (maxQX < QXU[iix+  (N_TX[0]*(acttx))] )
                   {
                        maxQX= QXU[iix+  (N_TX[0]*(acttx))] ;
//                         mexPrintf("QXU= %f, maxQ=%f \n", QXU[iix+  (N_TX[0]*(acttx))], maxQX);
                   }
               }
               if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                    mexPrintf("******* For X:   ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] * RX[ix+ (N_TX[0]*(iix+  (N_TX[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_X_Action[ix + (N_TX[0]*actx)] > 1)
            {
                maxQ=Number_X_Action[ix + (N_TX[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                        tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ  ;
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gax * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QXU[ix + (N_TX[0]*(actx))] = MMDX ;
            BXU[ix + (N_TX[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QXU[ix + (N_TX[0]*(actx))]);
            if (d2>maxQ)
                maxQ=d2;
            d2=maxQ;
            
//             mexPrintf("************** d2=%f  ,  QUX=%f , CI_r=%f *********** \n", d2, QXU[ix + (N_TX[0]*(actx))], CI_r);
            
        }
    }
    
//             mexPrintf("teta=%f, d2=%f \n", teta, d2);

    if (d2<teta)
        break;
}

// **************** FOR Y
while(true)
{
    d3=0;
    for (ix=0; ix<N_TY[0]; ix++)
    {
        for (actx=0; actx<N_TY[2]; actx++)
        {
            maxQ=1;
            if (Number_Y_Action[ix + (N_TY[0]*actx)] > 1)
            {
                maxQ=Number_Y_Action[ix + (N_TY[0]*actx)];
            }
            TmpC=pow((MAXReward_Y_Action[ix + (N_TY[0]*actx)]- MINReward_Y_Action[ix + (N_TY[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QYU[ix + (N_TY[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TY[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TY[2]; acttx++)
               {
                   sumQX=sumQX+QYU[iix+  (N_TY[0]*(acttx))];
                   if (maxQX < QYU[iix+  (N_TY[0]*(acttx))] )
                   {
                        maxQX= QYU[iix+  (N_TY[0]*(acttx))] ;
//                         mexPrintf("QYU= %f, maxQ=%f \n", QYU[iix+  (N_TY[0]*(acttx))], maxQX);
                   }
               }
                if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For Y:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UY[ctr]=maxQX;
                    PTempY[ctr] = PY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] ;
//                     mexPrintf("UY=%f,   PTemp=%f  , maxQX=%f \n",  UY[ctr], PTempY[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] * RY[ix+ (N_TY[0]*(iix+  (N_TY[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_Y_Action[ix + (N_TY[0]*actx)] > 1)
            {
                maxQ=Number_Y_Action[ix + (N_TY[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UY[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempY[js];
                        PTempY[js] = PTempY[is];
                        PTempY[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempY[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempY[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempY[Ind[0]]= %f  , Ind[0]=%f \n",  PTempY[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempY[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempY[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempY[ctr2] = maxQ ;
//                 mexPrintf("PTempY[Ind[ctr2]] =%f \n", PTempY[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempY[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempY[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempY=%f \n", MMDX, U2[ctrp], PTempY[ctrp] );
              }
            MMDX =   r + MMDX;   
            QYU[ix + (N_TY[0]*(actx))] = MMDX ;
            BYU[ix + (N_TY[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QYU[ix + (N_TY[0]*(actx))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUY=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QYU[ix + (N_TY[0]*(actx))], CI_r, CI_p);
            
        }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}

// *********** FOR IR up
while(true)
{
    d3=0;
    for (ix=0; ix<N_TI[0]; ix++)
    {
        for (actx=0; actx<N_TI[2]; actx++)
        {
            maxQ=1;
            if (Number_I_Action[ix + (N_TI[0]*actx)] > 1)
            {
                maxQ=Number_I_Action[ix + (N_TI[0]*actx)];
            }
            TmpC=pow((MAXReward_I_Action[ix + (N_TI[0]*actx)]- MINReward_I_Action[ix + (N_TI[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QIU[ix + (N_TI[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TI[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TI[2]; acttx++)
               {
                   sumQX=sumQX+QIU[iix+  (N_TI[0]*(acttx))];
                   if (maxQX < QIU[iix+  (N_TI[0]*(acttx))] )
                   {
                        maxQX= QIU[iix+  (N_TI[0]*(acttx))] ;
//                         mexPrintf("QIU= %f, maxQ=%f \n", QIU[iix+  (N_TI[0]*(acttx))], maxQX);
                   }
               }
//                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PI[ix+ (N_TI[0]*(iix+  (N_TI[1]*actx)))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PI[ix+ (N_TI[0]*(iix+  (N_TI[1]*actx)))] * RI[ix+ (N_TI[0]*(iix+  (N_TI[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_I_Action[ix + (N_TI[0]*actx)] > 1)
            {
                maxQ=Number_I_Action[ix + (N_TI[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ ;
//                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QIU[ix + (N_TI[0]*(actx))] = MMDX ;
            BIU[ix + (N_TI[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QIU[ix + (N_TI[0]*(actx))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIU[ix + (N_TI[0]*(actx))], CI_r, CI_p);
            
        }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}

// **************** FOR IR right
while(true)
{
    d3=0;
    for (ix=0; ix<N_TIr[0]; ix++)
    {
        for (actx=0; actx<N_TIr[2]; actx++)
        {
            maxQ=1;
            if (Number_Ir_Action[ix + (N_TIr[0]*actx)] > 1)
            {
                maxQ=Number_Ir_Action[ix + (N_TIr[0]*actx)];
            }
            TmpC=pow((MAXReward_Ir_Action[ix + (N_TIr[0]*actx)]- MINReward_Ir_Action[ix + (N_TIr[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QIrU[ix + (N_TIr[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TIr[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TIr[2]; acttx++)
               {
                   sumQX=sumQX+QIrU[iix+  (N_TIr[0]*(acttx))];
                   if (maxQX < QIrU[iix+  (N_TIr[0]*(acttx))] )
                   {
                        maxQX= QIrU[iix+  (N_TIr[0]*(acttx))] ;
//                         mexPrintf("QIrU= %f, maxQ=%f \n", QIrU[iix+  (N_TIr[0]*(acttx))], maxQX);
                   }
               }
//                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PIr[ix+ (N_TIr[0]*(iix+  (N_TIr[1]*actx)))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PIr[ix+ (N_TIr[0]*(iix+  (N_TIr[1]*actx)))] * RIr[ix+ (N_TIr[0]*(iix+  (N_TIr[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_Ir_Action[ix + (N_TIr[0]*actx)] > 1)
            {
                maxQ=Number_Ir_Action[ix + (N_TIr[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ ;
//                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QIrU[ix + (N_TIr[0]*(actx))] = MMDX ;
            BIrU[ix + (N_TIr[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QIrU[ix + (N_TIr[0]*(actx))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIrU[ix + (N_TIr[0]*(actx))], CI_r, CI_p);
            
        }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}

// *********** FOR IR down
while(true)
{
    d3=0;
    for (ix=0; ix<N_TId[0]; ix++)
    {
        for (actx=0; actx<N_TId[2]; actx++)
        {
            maxQ=1;
            if (Number_Id_Action[ix + (N_TId[0]*actx)] > 1)
            {
                maxQ=Number_Id_Action[ix + (N_TId[0]*actx)];
            }
            TmpC=pow((MAXReward_Id_Action[ix + (N_TId[0]*actx)]- MINReward_Id_Action[ix + (N_TId[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QIdU[ix + (N_TId[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TId[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TId[2]; acttx++)
               {
                   sumQX=sumQX+QIdU[iix+  (N_TId[0]*(acttx))];
                   if (maxQX < QIdU[iix+  (N_TId[0]*(acttx))] )
                   {
                        maxQX= QIdU[iix+  (N_TId[0]*(acttx))] ;
//                         mexPrintf("QIdU= %f, maxQ=%f \n", QIdU[iix+  (N_TId[0]*(acttx))], maxQX);
                   }
               }
//                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PId[ix+ (N_TId[0]*(iix+  (N_TId[1]*actx)))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PId[ix+ (N_TId[0]*(iix+  (N_TId[1]*actx)))] * RId[ix+ (N_TId[0]*(iix+  (N_TId[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_Id_Action[ix + (N_TId[0]*actx)] > 1)
            {
                maxQ=Number_Id_Action[ix + (N_TId[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ ;
//                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QIdU[ix + (N_TId[0]*(actx))] = MMDX ;
            BIdU[ix + (N_TId[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QIdU[ix + (N_TId[0]*(actx))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIdU[ix + (N_TId[0]*(actx))], CI_r, CI_p);
            
        }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}

// *********** FOR IR left
while(true)
{
    d3=0;
    for (ix=0; ix<N_TIl[0]; ix++)
    {
        for (actx=0; actx<N_TIl[2]; actx++)
        {
            maxQ=1;
            if (Number_Il_Action[ix + (N_TIl[0]*actx)] > 1)
            {
                maxQ=Number_Il_Action[ix + (N_TIl[0]*actx)];
            }
            TmpC=pow((MAXReward_Il_Action[ix + (N_TIl[0]*actx)]- MINReward_Il_Action[ix + (N_TIl[0]*actx)]),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QIlU[ix + (N_TIl[0]*(actx))];
            MMDX=0;

          for ( iix=0; iix<N_TIl[1]; iix++)
          {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TIl[2]; acttx++)
               {
                   sumQX=sumQX+QIlU[iix+  (N_TIl[0]*(acttx))];
                   if (maxQX < QIlU[iix+  (N_TIl[0]*(acttx))] )
                   {
                        maxQX= QIlU[iix+  (N_TIl[0]*(acttx))] ;
//                         mexPrintf("QIlU= %f, maxQ=%f \n", QIlU[iix+  (N_TIl[0]*(acttx))], maxQX);
                   }
               }
//                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PIl[ix+ (N_TIl[0]*(iix+  (N_TIl[1]*actx)))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PIl[ix+ (N_TIl[0]*(iix+  (N_TIl[1]*actx)))] * RIl[ix+ (N_TIl[0]*(iix+  (N_TIl[1]*actx)))] ) ; 
           }
            
             maxQ=1;
            if (Number_Il_Action[ix + (N_TIl[0]*actx)] > 1)
            {
                maxQ=Number_Il_Action[ix + (N_TIl[0]*actx)];
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ ;
//                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QIlU[ix + (N_TIl[0]*(actx))] = MMDX ;
            BIlU[ix + (N_TIl[0]*(actx))] = MMDX ;
           
            maxQ= fabs(qxu- QIlU[ix + (N_TIl[0]*(actx))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIlU[ix + (N_TIl[0]*(actx))], CI_r, CI_p);
            
        }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}

return;
}


