#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
// #define BU_OUT plhs[0]
#define BXYU_OUT plhs[0]
    
#define Trns_X2NX_Action prhs[0]
    
#define Reward_X_Action prhs[1]
    
#define NumberXA prhs[2]

#define Q2UX prhs[3]
    
#define MINRewardXA prhs[4]
#define MAXRewardXA prhs[5]

#define epsilon prhs[6]
#define gama prhs[7]
#define gamax prhs[8]
#define gamay prhs[9]
#define epi prhs[10]
#define Environment prhs[11]   
#define Delta prhs[12]    
#define NumC prhs[13]
#define LLS prhs[14]



int W=0;
double NC = mxGetScalar(NumC);
double LL2S = mxGetScalar(LLS);

size_t KX = mxGetNumberOfDimensions(Q2UX);
const mwSize *NX = mxGetDimensions(Q2UX);
double *QXU = mxGetPr(Q2UX);

double *Number_X_Action = mxGetPr(NumberXA);

double *MINReward_X_Action = mxGetPr(MINRewardXA);

double *MAXReward_X_Action = mxGetPr(MAXRewardXA);

size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);

double *Env = mxGetPr(Environment);
double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *BU, *BXU, *BYU, *BIU, *BIrU, *BIdU,*BIlU, *BXYU, *BXIU, *BYIU;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
  
int ix,iix, actx, acttx, iy, iiy;
double  sumQX, maxQX;
int itemp, jtemp, h1, h11, h2, h22, h3, h33;
int h4, h44, ic,iic, Hp, He, He2, He3;
double *X2, *Y2, *HP, *HE, *HE2, *HE3;
mxArray *X2Array, *Y2Array, *NHPArray, *NHEArray, *NHEArray2, *NHEArray3;

mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;


UArayX = mxCreateDoubleMatrix( (N_TX[2]*N_TX[3]*N_TX[5]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[2]*N_TX[3]*N_TX[5]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 

BXYU_OUT = mxCreateNumericArray(KX, NX, mxDOUBLE_CLASS, mxREAL);
BXU = mxGetPr(BXYU_OUT);

// mexPrintf("teta=%f", teta);
X2Array = mxCreateDoubleMatrix( LL2S , 1, mxREAL);
X2 = mxGetPr(X2Array); 

Y2Array = mxCreateDoubleMatrix( LL2S , 1, mxREAL);
Y2 = mxGetPr(Y2Array); 




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
while(true)
{
    d2=0;
    for (ix=1; ix< (N_TX[0]-1); ix++)
    {
        X2[0]=ix-1;
        X2[1]=ix;
        X2[2]=ix+1;
        
        for (iy=1; iy< (N_TX[1]-1); iy++)
        {
            Y2[0]=iy-1;
            Y2[1]=iy;
            Y2[2]=iy+1;
            
         for (ic=0; ic<N_TX[4]; ic++)
         {
            for (actx=0; actx<N_TX[6]; actx++)
            {
               
                maxQ=1;
                if (Number_X_Action[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] > 1)
                {
                    maxQ=Number_X_Action[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                }
                
                TmpC=pow((MAXReward_X_Action[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] - MINReward_X_Action[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ),2) / maxQ;
                 CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
                ctr=-1;
                Rewardx=0;  
                qxu=QXU[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                MMDX=0;

              for ( iix=0; iix<N_TX[2]; iix++)
              {
                  
               for (iiy=0; iiy<N_TX[3]; iiy++ )
               {
                   for ( iic=0; iic<NC; iic++ )
                   {    
                       itemp=iix;  // X2[iix];
                       jtemp =iiy;   //Y2[iiy];
                        sumQX=0;
                        maxQX=-10000000000;
                       for ( acttx=0; acttx<N_TX[6]; acttx++)
                       {
                           sumQX=sumQX+QXU[itemp + (N_TX[0] * ( jtemp + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                           if (maxQX < QXU[itemp + (N_TX[0] * ( jtemp + (N_TX[1]* (ic + (N_TX[4] * actx)))))] )
                           {
                                maxQX= QXU[itemp + (N_TX[0] * ( jtemp + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
        //                         mexPrintf("QXU= %f, maxQ=%f \n", QXU[iix+  (N_TX[0]*(acttx))], maxQX);
                           }
                       }
//                        if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
//                         {
        //                    mexPrintf("******* For X:   ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                           ctr ++;
                            UX[ctr]=maxQX;
                            PTempX[ctr] = PX[ix+ (N_TX[0]*( iy + (N_TX[1] * (iix+  (N_TX[2]* ( iiy + (N_TX[3] * (ic + (N_TX[4]* (iic + (N_TX[5] * actx))))))))))) ] ;
        //                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
//                         }
                        Rewardx=Rewardx+ ( PX[ix+ (N_TX[0]*( iy + (N_TX[1] * (iix+  (N_TX[2]* ( iiy + (N_TX[3] * (ic + (N_TX[4]* (iic + (N_TX[5] * actx))))))))))) ] * RX[ix+ (N_TX[0]*( iy + (N_TX[1] * (iix+  (N_TX[2]* ( iiy + (N_TX[3] * (ic + (N_TX[4]* (iic + (N_TX[5] * actx))))))))))) ] ) ; 
                    }
               }
              }

                 maxQ=1;
                if (Number_X_Action[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] > 1)
                {
                    maxQ=Number_X_Action[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                }
                CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
                if (ctr==0)
                    CI_p=0;

                UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                U2 = mxGetPr(UAray2); 
                IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                Ind = mxGetPr(IndArray); 

                 for (ctrp=0; ctrp<=ctr; ctrp++)
                {
                    U2[ctrp]=UX[ctrp];
                    Ind[ctrp]=ctrp;
                }

                for (is = 0; is <= ctr; is ++){
                    for(js = is + 1; js <= ctr; js++){
                        if(U2[js] > U2[is]){
                            tempQ = U2[js];
                            U2[js] = U2[is];
                            U2[is] = tempQ;
                            Indtemp = Ind[is];
                            Ind[is]=Ind[js];
                            Ind[js]=Indtemp;
                            tempQ = PTempX[js];
                            PTempX[js] = PTempX[is];
                            PTempX[is] = tempQ;
                        }
                    }
                }

                  r = Rewardx + CI_r ; // Upper Bound

                  SumPP = (PTempX[0] + (CI_p/2) ) ;
                  if (SumPP > 1)
                      SumPP=1;
                 PTempX[0] = SumPP;   
                 
//                  mexPrintf(f, "PTempX[0]=%f \n" , PTempX[0]);

    //               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
                  SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
                  
//                   mexPrintf(f, "SumP=%f \n" , SumP);
                  
                ctr2=ctr;
                while (SumP>1)
                {
                    SumPP = 1 - (SumP - PTempX[ctr2]);
                    maxQ= SumPP;
                    if (maxQ<0)
                        maxQ=0;
                    PTempX[ctr2] = maxQ  ;
                    ctr2=ctr2 - 1;
                    SumP=0;
                      for (ctrp=0; ctrp<=ctr; ctrp++)
                      {
                          SumP = SumP + PTempX[ctrp];
                      }
                }
                MMDX=0;
                for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      MMDX =MMDX + (gax * (U2[ctrp] * PTempX[ctrp]));
    //                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
                  }
                MMDX =   r + MMDX;   
                QXU[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))]  = MMDX ;
                BXU[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] = MMDX ;

                maxQ= fabs(qxu- QXU[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] );
                if (d2>maxQ)
                    maxQ=d2;
                d2=maxQ;

    //             mexPrintf("************** d2=%f  ,  QUX=%f , CI_r=%f *********** \n", d2, QXU[ix + (N_TX[0]*(actx))], CI_r);

            }
            }
        }
    }
    
//             mexPrintf("teta=%f, d2=%f \n", teta, d2);

    if (d2<teta)
        break;
}



return;
}