#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
#define BU_OUT plhs[0]
// #define BXU_OUT plhs[1]
// #define BYU_OUT plhs[2]
#define BIU_OUT plhs[1]
// #define BIrU_OUT plhs[4]
// #define BIdU_OUT plhs[5]
// #define BIlU_OUT plhs[6]
    
#define Trns_S2NS_Action prhs[0]
#define Trns_X2NX_Action prhs[1]
#define Trns_Y2NY_Action prhs[2]
#define Trns_I2NI_Action prhs[3]
#define Trns_Ir2NIr_Action prhs[4]
// #define Trns_Id2NId_Action prhs[5]
// #define Trns_Il2NIl_Action prhs[6]
    
#define Reward_S_Action prhs[5]
#define Reward_X_Action prhs[6]
#define Reward_Y_Action prhs[7]
#define Reward_I_Action prhs[8]
#define Reward_Ir_Action prhs[9]
// #define Reward_Id_Action prhs[12]
// #define Reward_Il_Action prhs[13]
    
#define NumberSA prhs[10]
#define NumberXA prhs[11]
#define NumberYA prhs[12]
#define NumberIA prhs[13]
#define NumberIrA prhs[14]
// #define NumberIdA prhs[19]
// #define NumberIlA prhs[20]
    
#define Q2U prhs[15]
#define Q2UX prhs[16]
#define Q2UY prhs[17]
#define Q2UI prhs[18]
#define Q2UIr prhs[19]
// #define Q2UId prhs[26]
// #define Q2UIl prhs[27]

#define MINRewardSA prhs[20]
#define MAXRewardSA prhs[21]
#define MINRewardXA prhs[22]
#define MAXRewardXA prhs[23]
#define MINRewardYA prhs[24]
#define MAXRewardYA prhs[25]
#define MINRewardIA prhs[26]
#define MAXRewardIA prhs[27]
#define MINRewardIrA prhs[28]
#define MAXRewardIrA prhs[29]
// #define MINRewardIdA prhs[38]
// #define MAXRewardIdA prhs[39]
// #define MINRewardIlA prhs[40]
// #define MAXRewardIlA prhs[41]

#define epsilon prhs[30]
#define gama prhs[31]
#define gamax prhs[32]
#define gamay prhs[33]
#define epi prhs[34]
#define Environment prhs[35]   
#define Delta prhs[36]    
    
#define NumC prhs[37]
#define LLJ prhs[38]
#define LLS prhs[39]
#define nhp prhs[40]
#define nhe prhs[41]


int W=0;
double NC = mxGetScalar(NumC);
double LL2S = mxGetScalar(LLS);
double LL2J = mxGetScalar(LLJ);
double NHP = mxGetScalar(nhp);
double NHE = mxGetScalar(nhe);


size_t KU = mxGetNumberOfDimensions(Q2U);
const mwSize *NU = mxGetDimensions(Q2U);
double *QU = mxGetPr(Q2U);

size_t KX = mxGetNumberOfDimensions(Q2UX);
const mwSize *NX = mxGetDimensions(Q2UX);
double *QXU = mxGetPr(Q2UX);

size_t KY = mxGetNumberOfDimensions(Q2UY);
const mwSize *NY = mxGetDimensions(Q2UY);
double *QYU = mxGetPr(Q2UY);

size_t KH = mxGetNumberOfDimensions(Q2UI);
const mwSize *NH = mxGetDimensions(Q2UI);
double *QIU = mxGetPr(Q2UI);

size_t KHE1 = mxGetNumberOfDimensions(Q2UIr);
const mwSize *NHE1 = mxGetDimensions(Q2UIr);
double *QIrU = mxGetPr(Q2UIr);

// size_t KHE2 = mxGetNumberOfDimensions(Q2UId);
// const mwSize *NHE2 = mxGetDimensions(Q2UId);
// double *QIdU = mxGetPr(Q2UId);
// 
// size_t KHE3 = mxGetNumberOfDimensions(Q2UIl);
// const mwSize *NHE3 = mxGetDimensions(Q2UIl);
// double *QIlU = mxGetPr(Q2UIl);

double *Number_S_Action = mxGetPr(NumberSA);
double *Number_X_Action = mxGetPr(NumberXA);
double *Number_Y_Action = mxGetPr(NumberYA);
double *Number_I_Action = mxGetPr(NumberIA);
double *Number_Ir_Action = mxGetPr(NumberIrA);
// double *Number_Id_Action = mxGetPr(NumberIdA);
// double *Number_Il_Action = mxGetPr(NumberIlA);

double *MINReward_S_Action = mxGetPr(MINRewardSA);
double *MINReward_X_Action = mxGetPr(MINRewardXA);
double *MINReward_Y_Action = mxGetPr(MINRewardYA);
double *MINReward_I_Action = mxGetPr(MINRewardIA);
double *MINReward_Ir_Action = mxGetPr(MINRewardIrA);
// double *MINReward_Id_Action = mxGetPr(MINRewardIdA);
// double *MINReward_Il_Action = mxGetPr(MINRewardIlA);

double *MAXReward_S_Action = mxGetPr(MAXRewardSA);
double *MAXReward_X_Action = mxGetPr(MAXRewardXA);
double *MAXReward_Y_Action = mxGetPr(MAXRewardYA);
double *MAXReward_I_Action = mxGetPr(MAXRewardIA);
double *MAXReward_Ir_Action = mxGetPr(MAXRewardIrA);
// double *MAXReward_Id_Action = mxGetPr(MAXRewardIdA);
// double *MAXReward_Il_Action = mxGetPr(MAXRewardIlA);

size_t K_T = mxGetNumberOfDimensions(Trns_S2NS_Action);
const mwSize *N_T = mxGetDimensions(Trns_S2NS_Action);
double *P = mxGetPr(Trns_S2NS_Action);
double *R = mxGetPr(Reward_S_Action);

size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);
size_t K_TY = mxGetNumberOfDimensions(Trns_Y2NY_Action);
const mwSize *N_TY = mxGetDimensions(Trns_Y2NY_Action);
double *PY = mxGetPr(Trns_Y2NY_Action);
double *RY = mxGetPr(Reward_Y_Action);
size_t K_TI = mxGetNumberOfDimensions(Trns_I2NI_Action);
const mwSize *N_TI = mxGetDimensions(Trns_I2NI_Action);
double *PI = mxGetPr(Trns_I2NI_Action);
double *RI = mxGetPr(Reward_I_Action);

size_t K_TIr = mxGetNumberOfDimensions(Trns_Ir2NIr_Action);
const mwSize *N_TIr = mxGetDimensions(Trns_Ir2NIr_Action);
double *PIr = mxGetPr(Trns_Ir2NIr_Action);
double *RIr = mxGetPr(Reward_Ir_Action);

// size_t K_TId = mxGetNumberOfDimensions(Trns_Id2NId_Action);
// const mwSize *N_TId = mxGetDimensions(Trns_Id2NId_Action);
// double *PId = mxGetPr(Trns_Id2NId_Action);
// double *RId = mxGetPr(Reward_Id_Action);
// 
// size_t K_TIl = mxGetNumberOfDimensions(Trns_Il2NIl_Action);
// const mwSize *N_TIl = mxGetDimensions(Trns_Il2NIl_Action);
// double *PIl = mxGetPr(Trns_Il2NIl_Action);
// double *RIl = mxGetPr(Reward_Il_Action);

double *Env = mxGetPr(Environment);
double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *BU, *BXU, *BYU, *BIU, *BIrU, *BIdU,*BIlU, *BXYU, *BXIU, *BYIU;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
  
int ix,iix, actx, acttx;
double  sumQX, maxQX;
int itemp, jtemp, h1, h11, h2, h22, h3, h33;
int h4, h44, ic,iic, Hp, He;
double *X2, *Y2, *HP, *HE;
mxArray *X2Array, *Y2Array, *NHPArray, *NHEArray;


mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;

UAray = mxCreateDoubleMatrix( (N_T[4]*N_T[5]*N_T[6]*N_T[7]) , 1, mxREAL);
U = mxGetPr(UAray); 
PTempAray = mxCreateDoubleMatrix( (N_T[4]*N_T[5]*N_T[6]*N_T[7]) , 1, mxREAL);
PTemp = mxGetPr(PTempAray); 


UArayX = mxCreateDoubleMatrix( (N_TX[1]*N_TX[3]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[1]*N_TX[3]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 

UArayY = mxCreateDoubleMatrix( (N_TY[1]*N_TY[3] ) , 1, mxREAL);
UY = mxGetPr(UArayY); 
PTempArayY = mxCreateDoubleMatrix( (N_TY[1]*N_TY[3]) , 1, mxREAL);
PTempY = mxGetPr(PTempArayY); 

BU_OUT = mxCreateNumericArray(KU, NU, mxDOUBLE_CLASS, mxREAL);
BU = mxGetPr(BU_OUT);

// BXU_OUT = mxCreateNumericArray(KX, NX, mxDOUBLE_CLASS, mxREAL);
// BXU = mxGetPr(BXU_OUT);
 
// BYU_OUT = mxCreateNumericArray(KY, NY, mxDOUBLE_CLASS, mxREAL);
// BYU = mxGetPr(BYU_OUT);

BIU_OUT = mxCreateNumericArray(KH, NH, mxDOUBLE_CLASS, mxREAL);
BIU = mxGetPr(BIU_OUT);

// BIrU_OUT = mxCreateNumericArray(KHE1, NHE1, mxDOUBLE_CLASS, mxREAL);
// BIrU = mxGetPr(BIrU_OUT);

// BIdU_OUT = mxCreateNumericArray(KHE2, NHE2, mxDOUBLE_CLASS, mxREAL);
// BIdU = mxGetPr(BIdU_OUT);
// 
// BIlU_OUT = mxCreateNumericArray(KHE3, NHE3, mxDOUBLE_CLASS, mxREAL);
// BIlU = mxGetPr(BIlU_OUT);

// mexPrintf("teta=%f", teta);
X2Array = mxCreateDoubleMatrix( LL2J , 1, mxREAL);
X2 = mxGetPr(X2Array); 
Y2Array = mxCreateDoubleMatrix( LL2J , 1, mxREAL);
Y2 = mxGetPr(Y2Array); 
NHPArray = mxCreateDoubleMatrix( NHP , 1, mxREAL);
HP = mxGetPr(NHPArray); 
NHEArray = mxCreateDoubleMatrix( NHE , 1, mxREAL);
HE = mxGetPr(NHEArray); 


// for (W=0; W<50; W++)
while(true)
{
    d1=0;
     d2=0;
     d3=0;
    
    for ( i=1 ; i<(N_T[0]-1); i++)
    {
        for ( j=1; j<(N_T[1]-1); j++)
        {
            X2[0]=i-1;
            X2[1]=i;
            X2[2]=i+1;
            Y2[0]=j-1;
            Y2[1]=j;
            Y2[2]=j+1;
            
            for (h1=0; h1<(N_T[2]); h1++)
            {
                HP[0]=h1;
                if (h1==0)
                    {HP[1]=h1;}
                else
                    {HP[1]=h1-1;}
                
                for(h2=0; h2<(N_T[3]); h2++)
                {
                     HE[0]=h2;
                    if (h2==0)
                        {HE[1]=h2;}
                    else
                        {HE[1]=h2-1;}
                     
//                     for(h3=0; h3<(N_T[4]); h3++)
//                     {
//                         for(h4=0; h4<(N_T[5]); h4++)
//                         {
                            for ( act=0; act<N_T[8]; act++)
                             {

                             {

                    maxQ=1;
                     if ( Number_S_Action[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] > 1)
                        maxQ = Number_S_Action[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] ;
                    TmpC=(pow( (MAXReward_S_Action[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] - MINReward_S_Action[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] ), 2 )) / maxQ;
                     CI_r = sqrt( ((log((2/delta))/2)*TmpC) );
            
                      ctr= -1;
                      Reward=0;
                      q= QU[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] ;
                      for ( ii=0; ii<(N_T[4]) ; ii++)
                            {
                                 for ( jj=0; jj<(N_T[5]) ; jj++)
                                {    
                                    itemp=X2[ii];
                                    jtemp=Y2[jj];
                                    for (h11=0; h11<(N_T[6]); h11++)
                                    {
                                        Hp=HP[h11];
                                        for(h22=0; h22<(N_T[7]); h22++)
                                        {
                                            He= HE[h22];
//                                             for(h33=0; h33<(N_T[10]); h33++)
//                                             {
//                                                 for(h44=0; h44<(N_T[11]); h44++)
//                                                 {
                                                       sumQ=0;
                                                       maxQ=-1000;
                                                       for ( actt=0; actt<N_T[8]; actt++)
                                                       {
                                                           sumQ=sumQ+QU[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* ( actt))))))))];
                                                           if (maxQ < QU[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* ( actt))))))))] )
                                                           {
                                                                maxQ=QU[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* ( actt))))))))] ;
                                                           }
                                                        }
                                                        ctr = ctr + 1;
                                                        U[ctr]=maxQ;
                                                        PTemp[ctr] = P[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act))))))))))))))) ]  ;   
                                                            
                                                        Reward=Reward+(P[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act)))))))))))))))]* R[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act))))))))))))))) ] ) ; 
//                                                      }
//                                                  }
                                            
                                        }
                                    }
                                 }
                      }
                      
                        UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                        U2 = mxGetPr(UAray2); 
                        IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
                        Ind = mxGetPr(IndArray); 
                                           
                        for (ctrp=0; ctrp<=ctr; ctrp++)
                        {
                            U2[ctrp]=U[ctrp];
                            Ind[ctrp]=ctrp;
                        }
                                                
                            for (is = 0; is <= ctr; is ++){
                                for(js = is + 1; js <= ctr; js++){
                                    if(U2[js] < U2[is]){
                                        tempQ = U2[js];
                                        U2[js] = U2[is];
                                        U2[is] = tempQ;
                                        Indtemp = Ind[is];
                                        Ind[is]=Ind[js];
                                        Ind[js]=Indtemp;
                                         tempQ = PTemp[js];
                                        PTemp[js] = PTemp[is];
                                        PTemp[is] = tempQ;
                                    }
                                }
                            }
                        
                             maxQ=1;
                              if ( Number_S_Action[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] > 1)
                                   maxQ = Number_S_Action[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))];
                      
                            CI_p = sqrt( (2*(log((( pow( 2, (ctr+1) )) - 2)) - log(delta))) / (maxQ) );   
                            if (ctr==0)
                                CI_p=0;
                              r = Reward - CI_r ; // Upper Bound
                              SumPP = (PTemp[0] + (CI_p/2) );
                              if (SumPP > 1)
                                  SumPP=1;
                              PTemp[0] = SumPP;
                              SumP=0;
                              for (ctrp=0; ctrp<=ctr; ctrp++)
                              {
                                  SumP = SumP + PTemp[ctrp];
                              }
                              
                            ctr2=ctr;
                            while (SumP>1)
                            {
                                SumPP = 1 - (SumP - PTemp[ctr2]);
                                maxQ= SumPP;
                                if (maxQ<0)
                                    maxQ=0;
                                PTemp[ctr2] = maxQ  ;
                                ctr2=ctr2 - 1;
                                SumP=0;
                                  for (ctrp=0; ctrp<=ctr; ctrp++)
                                  {
                                      SumP = SumP + PTemp[ctrp];
                                  }
                            }
                            MMD=0;
                            for (ctrp=0; ctrp<=ctr; ctrp++)
                              {
                                  MMD =MMD + (ga * (U2[ctrp] * PTemp[ctrp]));
                              }
                            MMD =   r + MMD;
                            QU[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] = MMD ;  // uper bound
                            BU[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))] = MMD ;  // uper bound
                                           
                           maxQ=fabs(q- QU[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]*( act))))))))]);
                           if (d1>maxQ)
                                   maxQ=d1;
                            d1=maxQ;
//                           mexPrintf("************** d1=%f  ,  QU=%f  ***********, CI_r=%f \n", d1, QU[i +( N_T[0]*(j + (N_T[1]*act)))], CI_r);
                    

                                 }
//                             }
//                         }
                    }
                }
            }
        }
    }
//         mexPrintf("teta=%f, d1=%f \n", teta, d1);
      if (d1<teta)
        break;
        
    } // end while




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


while(true)
{
    d3=0;
    for (ix=0; ix<N_TI[0]; ix++)
    {
        HP[0]=ix;
        if (ix==0)
            {HP[1]=ix;}
        else
            {HP[1]=ix-1;}
        for (ic=0; ic<N_TI[2]; ic++)
        {
        for (actx=0; actx<N_TI[4]; actx++)
        {
            maxQ=1;
            if (Number_I_Action[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] > 1)
            {
                maxQ=Number_I_Action[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] ;
            }
            TmpC=pow((MAXReward_I_Action[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] - MINReward_I_Action[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] ),2) / maxQ;
             CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
            ctr=-1;
            Rewardx=0;  
            qxu=QIU[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] ;
            MMDX=0;

          for ( iix=0; iix<N_TI[1]; iix++)
          {
              Hp=HP[iix];
              for ( iic=0; iic<NC; iic++ )
                {
                sumQX=0;
                maxQX=-1000;
               for ( acttx=0; acttx<N_TI[4]; acttx++)
               {
                   sumQX=sumQX+QIU[Hp+ (N_TI[0]*( iic +( N_TI[2]* acttx)))]  ;
                   if (maxQX < QIU[Hp+ (N_TI[0]*( iic +( N_TI[2]* acttx)))] )
                   {
                        maxQX= QIU[Hp+ (N_TI[0]*( iic +( N_TI[2]* acttx)))] ;
//                         mexPrintf("QIU= %f, maxQ=%f \n", QIU[iix+  (N_TI[0]*(acttx))], maxQX);
                   }
               }
//                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
                {
//                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
                   ctr ++;
                    UX[ctr]=maxQX;
                    PTempX[ctr] = PI[ix+ (N_TI[0]*(iix+  (N_TI[1]* ( ic + (N_TI[2] * (iic + (N_TI[3] *actx)))))))] ;
//                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
                }
                Rewardx=Rewardx+ (  PI[ix+ (N_TI[0]*(iix+  (N_TI[1]* ( ic + (N_TI[2] * (iic + (N_TI[3] *actx)))))))] * RI[ix+ (N_TI[0]*(iix+  (N_TI[1]* ( ic + (N_TI[2] * (iic + (N_TI[3] *actx)))))))] ) ; 
           }
          }
            
             maxQ=1;
            if (Number_I_Action[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] > 1)
            {
                maxQ=Number_I_Action[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] ;
            }
            CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
            if (ctr==0)
                CI_p=0;
            
            UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            U2 = mxGetPr(UAray2); 
            IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
            Ind = mxGetPr(IndArray); 
                        
             for (ctrp=0; ctrp<=ctr; ctrp++)
            {
                U2[ctrp]=UX[ctrp];
                Ind[ctrp]=ctrp;
            }
                                                
            for (is = 0; is <= ctr; is ++){
                for(js = is + 1; js <= ctr; js++){
                    if(U2[js] < U2[is]){
                        tempQ = U2[js];
                        U2[js] = U2[is];
                        U2[is] = tempQ;
                        Indtemp = Ind[is];
                        Ind[is]=Ind[js];
                        Ind[js]=Indtemp;
                         tempQ = PTempX[js];
                        PTempX[js] = PTempX[is];
                        PTempX[is] = tempQ;
                    }
                }
            }
                        
            
            
//              SortInput[0]=UArayX;
//              SortInput[1]=mxCreateString("descend"); // Upper Bound
//              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
//              SUX= mxGetPr(SortOut[0]);
//              SInX= mxGetPr(SortOut[1]);
            
              r = Rewardx - CI_r ; // Upper Bound
              
              SumPP = (PTempX[0] + (CI_p/2) ) ;
              if (SumPP > 1)
                  SumPP=1;
             PTempX[0] = SumPP;                 
                              
//               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
//              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
              SumP=0;
              for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  SumP = SumP + PTempX[ctrp];
              }
            ctr2=ctr;
            while (SumP>1)
            {
                SumPP = 1 - (SumP - PTempX[ctr2]);
                maxQ= SumPP;
                if (maxQ<0)
                    maxQ=0;
                PTempX[ctr2] = maxQ ;
//                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
                ctr2=ctr2 - 1;
                SumP=0;
                  for (ctrp=0; ctrp<=ctr; ctrp++)
                  {
                      SumP = SumP + PTempX[ctrp];
                  }
            }
            MMDX=0;
            for (ctrp=0; ctrp<=ctr; ctrp++)
              {
                  MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
//                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
              }
            MMDX =   r + MMDX;   
            QIU[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] = MMDX ;
            BIU[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] = MMDX ;
           
            maxQ= fabs(qxu- QIU[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIU[ix + (N_TI[0]*(actx))], CI_r, CI_p);
            
        }
    }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}

// ************* FOR IR right
// while(true)
// {
//     d3=0;
//     for (ix=0; ix<N_TIr[0]; ix++)
//     {
//          HE[0]=ix;
//         if (ix==0)
//             {HE[1]=ix;}
//         else
//             {HE[1]=ix-1;}
//          
//         for (ic=0; ic<N_TIr[2]; ic++)
//         {
//         for (actx=0; actx<N_TIr[4]; actx++)
//         {
//             maxQ=1;
//             if (Number_Ir_Action[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))] > 1)
//             {
//                 maxQ=Number_Ir_Action[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))];
//             }
//             TmpC=pow((MAXReward_Ir_Action[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))] - MINReward_Ir_Action[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))] ),2) / maxQ;
//              CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
//             ctr=-1;
//             Rewardx=0;  
//             qxu=QIrU[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))];
//             MMDX=0;
// 
//           for ( iix=0; iix<N_TIr[1]; iix++)
//           {
//               He= HE[iix];
//               
//                for ( iic=0; iic<NC; iic++ )
//                 {
//                 sumQX=0;
//                 maxQX=-1000;
//                for ( acttx=0; acttx<N_TIr[4]; acttx++)
//                {
//                    sumQX=sumQX+QIrU[He+ (N_TIr[0]*( iic +( N_TIr[2]* acttx)))] ;
//                    if (maxQX < QIrU[He+ (N_TIr[0]*( iic +( N_TIr[2]* acttx)))] )
//                    {
//                         maxQX= QIrU[He+ (N_TIr[0]*( iic +( N_TIr[2]* acttx)))] ;
// //                         mexPrintf("QIrU= %f, maxQ=%f \n", QIrU[iix+  (N_TIr[0]*(acttx))], maxQX);
//                    }
//                }
// //                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
//                 {
// //                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
//                    ctr ++;
//                     UX[ctr]=maxQX;
//                     PTempX[ctr] = PIr[ix+ (N_TIr[0]*(iix+  (N_TIr[1]* ( ic + (N_TIr[2] * (iic + (N_TIr[3] *actx)))))))] ;
// //                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
//                 }
//                 Rewardx=Rewardx+ (  PIr[ix+ (N_TIr[0]*(iix+  (N_TIr[1]* ( ic + (N_TIr[2] * (iic + (N_TIr[3] *actx)))))))] * RIr[ix+ (N_TIr[0]*(iix+  (N_TIr[1]* ( ic + (N_TIr[2] * (iic + (N_TIr[3] *actx)))))))]  ) ; 
//            }
//           }
//             
//              maxQ=1;
//             if (Number_Ir_Action[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))] > 1)
//             {
//                 maxQ=Number_Ir_Action[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))];
//             }
//             CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
//             if (ctr==0)
//                 CI_p=0;
//             
//             UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
//             U2 = mxGetPr(UAray2); 
//             IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
//             Ind = mxGetPr(IndArray); 
//                         
//              for (ctrp=0; ctrp<=ctr; ctrp++)
//             {
//                 U2[ctrp]=UX[ctrp];
//                 Ind[ctrp]=ctrp;
//             }
//                                                 
//             for (is = 0; is <= ctr; is ++){
//                 for(js = is + 1; js <= ctr; js++){
//                     if(U2[js] < U2[is]){
//                         tempQ = U2[js];
//                         U2[js] = U2[is];
//                         U2[is] = tempQ;
//                         Indtemp = Ind[is];
//                         Ind[is]=Ind[js];
//                         Ind[js]=Indtemp;
//                          tempQ = PTempX[js];
//                         PTempX[js] = PTempX[is];
//                         PTempX[is] = tempQ;
//                     }
//                 }
//             }
//                         
//             
//             
// //              SortInput[0]=UArayX;
// //              SortInput[1]=mxCreateString("descend"); // Upper Bound
// //              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
// //              SUX= mxGetPr(SortOut[0]);
// //              SInX= mxGetPr(SortOut[1]);
//             
//               r = Rewardx - CI_r ; // Upper Bound
//               
//               SumPP = (PTempX[0] + (CI_p/2) ) ;
//               if (SumPP > 1)
//                   SumPP=1;
//              PTempX[0] = SumPP;                 
//                               
// //               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
// //              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
//               SumP=0;
//               for (ctrp=0; ctrp<=ctr; ctrp++)
//               {
//                   SumP = SumP + PTempX[ctrp];
//               }
//             ctr2=ctr;
//             while (SumP>1)
//             {
//                 SumPP = 1 - (SumP - PTempX[ctr2]);
//                 maxQ= SumPP;
//                 if (maxQ<0)
//                     maxQ=0;
//                 PTempX[ctr2] = maxQ ;
// //                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
//                 ctr2=ctr2 - 1;
//                 SumP=0;
//                   for (ctrp=0; ctrp<=ctr; ctrp++)
//                   {
//                       SumP = SumP + PTempX[ctrp];
//                   }
//             }
//             MMDX=0;
//             for (ctrp=0; ctrp<=ctr; ctrp++)
//               {
//                   MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
// //                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
//               }
//             MMDX =   r + MMDX;   
//             QIrU[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))] = MMDX ;
//             BIrU[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))] = MMDX ;
//            
//             maxQ= fabs(qxu- QIrU[ix + (N_TIr[0]*(ic + (N_TIr[2] * actx)))]);
//             if (d3>maxQ)
//                 maxQ=d3;
//             d3=maxQ;
//             
// //             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIrU[ix + (N_TIr[0]*(actx))], CI_r, CI_p);
//             
//         }
//     }
//     }
//     
// //             mexPrintf("teta=%f, d3=%f \n", teta, d3);
// 
//     if (d3<teta)
//         break;
// }

// *********** FOR IR down
// while(true)
// {
//     d3=0;
//     for (ix=0; ix<N_TId[0]; ix++)
//     {
//         for (ic=0; ic<N_TId[2]; ic++)
//         {
//         for (actx=0; actx<N_TId[4]; actx++)
//         {
//             maxQ=1;
//             if (Number_Id_Action[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] > 1)
//             {
//                 maxQ=Number_Id_Action[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] ;
//             }
//             TmpC=pow((MAXReward_Id_Action[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] - MINReward_Id_Action[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] ),2) / maxQ;
//              CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
//             ctr=-1;
//             Rewardx=0;  
//             qxu=QIdU[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] ;
//             MMDX=0;
// 
//           for ( iix=0; iix<N_TId[1]; iix++)
//           {
//                for ( iic=0; iic<NC; iic++ )
//                 {
//                 sumQX=0;
//                 maxQX=-1000;
//                for ( acttx=0; acttx<N_TId[4]; acttx++)
//                {
//                    sumQX=sumQX+QIdU[iix + (N_TId[1]*(iic + (N_TId[3] * acttx)))] ;
//                    if (maxQX < QIdU[iix + (N_TId[1]*(iic + (N_TId[3] * acttx)))] )
//                    {
//                         maxQX= QIdU[iix + (N_TId[1]*(iic + (N_TId[3] * acttx)))] ;
// //                         mexPrintf("QIdU= %f, maxQ=%f \n", QIdU[iix+  (N_TId[0]*(acttx))], maxQX);
//                    }
//                }
// //                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
//                 {
// //                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
//                    ctr ++;
//                     UX[ctr]=maxQX;
//                     PTempX[ctr] = PId[ix+ (N_TId[0]*(iix+  (N_TId[1]* ( ic + (N_TId[2] * (iic + (N_TId[3] *actx)))))))]  ;
// //                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
//                 }
//                 Rewardx=Rewardx+ (  PId[ix+ (N_TId[0]*(iix+  (N_TId[1]* ( ic + (N_TId[2] * (iic + (N_TId[3] *actx)))))))] * RId[ix+ (N_TId[0]*(iix+  (N_TId[1]* ( ic + (N_TId[2] * (iic + (N_TId[3] *actx)))))))] ) ; 
//            }
//           }
//             
//              maxQ=1;
//             if (Number_Id_Action[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] > 1)
//             {
//                 maxQ=Number_Id_Action[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] ;
//             }
//             CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
//             if (ctr==0)
//                 CI_p=0;
//             
//             UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
//             U2 = mxGetPr(UAray2); 
//             IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
//             Ind = mxGetPr(IndArray); 
//                         
//              for (ctrp=0; ctrp<=ctr; ctrp++)
//             {
//                 U2[ctrp]=UX[ctrp];
//                 Ind[ctrp]=ctrp;
//             }
//                                                 
//             for (is = 0; is <= ctr; is ++){
//                 for(js = is + 1; js <= ctr; js++){
//                     if(U2[js] > U2[is]){
//                         tempQ = U2[js];
//                         U2[js] = U2[is];
//                         U2[is] = tempQ;
//                         Indtemp = Ind[is];
//                         Ind[is]=Ind[js];
//                         Ind[js]=Indtemp;
//                          tempQ = PTempX[js];
//                         PTempX[js] = PTempX[is];
//                         PTempX[is] = tempQ;
//                     }
//                 }
//             }
//                         
//             
//             
// //              SortInput[0]=UArayX;
// //              SortInput[1]=mxCreateString("descend"); // Upper Bound
// //              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
// //              SUX= mxGetPr(SortOut[0]);
// //              SInX= mxGetPr(SortOut[1]);
//             
//               r = Rewardx + CI_r ; // Upper Bound
//               
//               SumPP = (PTempX[0] + (CI_p/2) ) ;
//               if (SumPP > 1)
//                   SumPP=1;
//              PTempX[0] = SumPP;                 
//                               
// //               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
// //              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
//               SumP=0;
//               for (ctrp=0; ctrp<=ctr; ctrp++)
//               {
//                   SumP = SumP + PTempX[ctrp];
//               }
//             ctr2=ctr;
//             while (SumP>1)
//             {
//                 SumPP = 1 - (SumP - PTempX[ctr2]);
//                 maxQ= SumPP;
//                 if (maxQ<0)
//                     maxQ=0;
//                 PTempX[ctr2] = maxQ ;
// //                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
//                 ctr2=ctr2 - 1;
//                 SumP=0;
//                   for (ctrp=0; ctrp<=ctr; ctrp++)
//                   {
//                       SumP = SumP + PTempX[ctrp];
//                   }
//             }
//             MMDX=0;
//             for (ctrp=0; ctrp<=ctr; ctrp++)
//               {
//                   MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
// //                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
//               }
//             MMDX =   r + MMDX;   
//             QIdU[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] = MMDX ;
//             BIdU[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] = MMDX ;
//            
//             maxQ= fabs(qxu- QIdU[ix + (N_TId[0]*(ic + (N_TId[2] * actx)))] );
//             if (d3>maxQ)
//                 maxQ=d3;
//             d3=maxQ;
//             
// //             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIdU[ix + (N_TId[0]*(actx))], CI_r, CI_p);
//             
//         }
//         }
//     }
//     
// //             mexPrintf("teta=%f, d3=%f \n", teta, d3);
// 
//     if (d3<teta)
//         break;
// }
// 
// // ********** FOR IR left
// while(true)
// {
//     d3=0;
//     for (ix=0; ix<N_TIl[0]; ix++)
//     {
//         for (ic=0; ic<N_TIl[2]; ic++)
//         {
//         for (actx=0; actx<N_TIl[4]; actx++)
//         {
//             maxQ=1;
//             if (Number_Il_Action[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))] > 1)
//             {
//                 maxQ=Number_Il_Action[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))]  ;
//             }
//             TmpC=pow((MAXReward_Il_Action[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))]  - MINReward_Il_Action[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))] ),2) / maxQ;
//              CI_r = sqrt( ((log((2/delta))/2)*TmpC) );       
//             ctr=-1;
//             Rewardx=0;  
//             qxu=QIlU[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))] ;
//             MMDX=0;
// 
//           for ( iix=0; iix<N_TIl[1]; iix++)
//           {
//                for ( iic=0; iic<NC; iic++ )
//                 {
//                 sumQX=0;
//                 maxQX=-1000;
//                for ( acttx=0; acttx<N_TIl[4]; acttx++)
//                {
//                    sumQX=sumQX+QIlU[iix + (N_TIl[1]*(iic + (N_TIl[3] * acttx)))];
//                    if (maxQX < QIlU[iix + (N_TIl[1]*(iic + (N_TIl[3] * acttx)))] )
//                    {
//                         maxQX= QIlU[iix + (N_TIl[1]*(iic + (N_TIl[3] * acttx)))] ;
// //                         mexPrintf("QIlU= %f, maxQ=%f \n", QIlU[iix+  (N_TIl[0]*(acttx))], maxQX);
//                    }
//                }
// //                 if ( iix==(ix-1) || iix==ix || iix==(ix+1) )
//                 {
// //                     mexPrintf("*******  For I:  ix=%d,    iix=%d,   actx=%d   \n", ix, iix, actx);
//                    ctr ++;
//                     UX[ctr]=maxQX;
//                     PTempX[ctr] = PIl[ix+ (N_TIl[0]*(iix+  (N_TIl[1]* ( ic + (N_TIl[2] * (iic + (N_TIl[3] *actx)))))))] ;
// //                     mexPrintf("UX=%f,   PTemp=%f  , maxQX=%f \n",  UX[ctr], PTempX[ctr], maxQX );
//                 }
//                 Rewardx=Rewardx+ (  PIl[ix+ (N_TIl[0]*(iix+  (N_TIl[1]* ( ic + (N_TIl[2] * (iic + (N_TIl[3] *actx)))))))] * RIl[ix+ (N_TIl[0]*(iix+  (N_TIl[1]* ( ic + (N_TIl[2] * (iic + (N_TIl[3] *actx)))))))] ) ; 
//                }
//            }
//             
//              maxQ=1;
//             if (Number_Il_Action[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))]  > 1)
//             {
//                 maxQ=Number_Il_Action[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))]  ;
//             }
//             CI_p = sqrt( (2*(log(((pow(2, (ctr+1))) - 2)) - log(delta))) / maxQ );   
//             if (ctr==0)
//                 CI_p=0;
//             
//             UAray2 = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
//             U2 = mxGetPr(UAray2); 
//             IndArray = mxCreateDoubleMatrix( (ctr+1) , 1, mxREAL);
//             Ind = mxGetPr(IndArray); 
//                         
//              for (ctrp=0; ctrp<=ctr; ctrp++)
//             {
//                 U2[ctrp]=UX[ctrp];
//                 Ind[ctrp]=ctrp;
//             }
//                                                 
//             for (is = 0; is <= ctr; is ++){
//                 for(js = is + 1; js <= ctr; js++){
//                     if(U2[js] > U2[is]){
//                         tempQ = U2[js];
//                         U2[js] = U2[is];
//                         U2[is] = tempQ;
//                         Indtemp = Ind[is];
//                         Ind[is]=Ind[js];
//                         Ind[js]=Indtemp;
//                          tempQ = PTempX[js];
//                         PTempX[js] = PTempX[is];
//                         PTempX[is] = tempQ;
//                     }
//                 }
//             }
//                         
//             
//             
// //              SortInput[0]=UArayX;
// //              SortInput[1]=mxCreateString("descend"); // Upper Bound
// //              mexCallMATLAB(2, SortOut, 2, &SortInput, "sort");
// //              SUX= mxGetPr(SortOut[0]);
// //              SInX= mxGetPr(SortOut[1]);
//             
//               r = Rewardx + CI_r ; // Upper Bound
//               
//               SumPP = (PTempX[0] + (CI_p/2) ) ;
//               if (SumPP > 1)
//                   SumPP=1;
//              PTempX[0] = SumPP;                 
//                               
// //               PTempX[Ind[0]] = min(1,  (PTempX[SInX[0]] + (CI_p/2) ));
// //              mexPrintf(" PTempX[Ind[0]]= %f  , Ind[0]=%f \n",  PTempX[Ind[0]], Ind[0]);
//               SumP=0;
//               for (ctrp=0; ctrp<=ctr; ctrp++)
//               {
//                   SumP = SumP + PTempX[ctrp];
//               }
//             ctr2=ctr;
//             while (SumP>1)
//             {
//                 SumPP = 1 - (SumP - PTempX[ctr2]);
//                 maxQ= SumPP;
//                 if (maxQ<0)
//                     maxQ=0;
//                 PTempX[ctr2] = maxQ ;
// //                 mexPrintf("PTempX[Ind[ctr2]] =%f \n", PTempX[Ind[ctr2]] );
//                 ctr2=ctr2 - 1;
//                 SumP=0;
//                   for (ctrp=0; ctrp<=ctr; ctrp++)
//                   {
//                       SumP = SumP + PTempX[ctrp];
//                   }
//             }
//             MMDX=0;
//             for (ctrp=0; ctrp<=ctr; ctrp++)
//               {
//                   MMDX =MMDX + (gay * (U2[ctrp] * PTempX[ctrp]));
// //                   mexPrintf("**** MMDX=%f , U2=%f  ,   PTempX=%f \n", MMDX, U2[ctrp], PTempX[ctrp] );
//               }
//             MMDX =   r + MMDX;   
//             QIlU[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))]  = MMDX ;
//             BIlU[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))]  = MMDX ;
//            
//             maxQ= fabs(qxu- QIlU[ix + (N_TIl[0]*(ic + (N_TIl[2] * actx)))] );
//             if (d3>maxQ)
//                 maxQ=d3;
//             d3=maxQ;
//             
// //             mexPrintf("************** d3=%f  ,  QUX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QIlU[ix + (N_TIl[0]*(actx))], CI_r, CI_p);
//             
//         }
//         }
//     }
//     
// //             mexPrintf("teta=%f, d3=%f \n", teta, d3);
// 
//     if (d3<teta)
//         break;
// }


return;
}