#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
#define BX_OUT plhs[0]
// #define BY_OUT plhs[1]
// #define BH_OUT plhs[2]
    
#define Trns_X2NX_Action prhs[0]
// #define Trns_Y2NY_Action prhs[1]
// #define Trns_I2NI_Action prhs[2]

#define Reward_X_Action prhs[1]
// #define Reward_Y_Action prhs[4]
// #define Reward_I_Action prhs[5]
 
#define Q2X prhs[2]
// #define Q2Y prhs[7]
// #define Q2I prhs[8]

#define epsilon prhs[3]
#define gama prhs[4]
#define gamax prhs[5]
#define gamay prhs[6]
#define epi prhs[7]
#define Environment prhs[8]   
#define Delta prhs[9] 
#define NumC prhs[10]
#define LLS prhs[11]

       


size_t KX = mxGetNumberOfDimensions(Q2X);
const mwSize *NX = mxGetDimensions(Q2X);
double *QX = mxGetPr(Q2X);


int W=0;
double NC = mxGetScalar(NumC);
double LL2S = mxGetScalar(LLS);


size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);


double *Env = mxGetPr(Environment);
double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *B, *BX, *BY, *BI, *BIr, *BId,*BIl, *BXY, *BXI, *BYI;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
double QN;
  
int ix,iix, actx, acttx;
double  sumQX, maxQX;
int itemp, jtemp, h1, h11, h2, h22, h3, h33, Hp, He, He2, He3;
int h4, h44, ic,iic;
double *X2, *Y2, *HP, *HE, *HE2, *HE3;
mxArray *X2Array, *Y2Array, *NHPArray, *NHEArray, *NHEArray2, *NHEArray3;


mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;
double QNX;


UArayX = mxCreateDoubleMatrix( (N_TX[1]*N_TX[3]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[1]*N_TX[3]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 


BX_OUT = mxCreateNumericArray(KX, NX, mxDOUBLE_CLASS, mxREAL);
BX = mxGetPr(BX_OUT);
 

// mexPrintf("teta=%f", teta);
X2Array = mxCreateDoubleMatrix( LL2S , 1, mxREAL);
X2 = mxGetPr(X2Array); 
Y2Array = mxCreateDoubleMatrix( LL2S , 1, mxREAL);
Y2 = mxGetPr(Y2Array); 

while(true)
{
    d2=0;
    for (ix=0; ix< (N_TX[0]); ix++)
    {
        X2[0]=ix-2;
        X2[1]=ix-1;
        X2[2]=ix;
        X2[3]=ix+1;
        X2[4]=ix+2;
        
        if (ix==0)
            { X2[0]=ix; X2[1]=ix; }
        if (ix==1)
            { X2[0]=ix-1; }
        if ( ix== (N_TX[0]-1) )
            { X2[3]=ix; X2[4]=ix; }
        if ( ix== (N_TX[0]-2) )
            { X2[4]=ix+1; }
            
         for (ic=0; ic<N_TX[2]; ic++)
         {
            for (actx=0; actx<N_TX[4]; actx++)
            { 
                qxu=QX[ix + (N_TX[0]*(ic + (N_TX[2] * actx)))] ;
                MMDX=0;

              for ( iix=0; iix<N_TX[1]; iix++)
              {
                   
                   for ( iic=0; iic<NC; iic++ )
                   {    
                       itemp= X2[iix];
                        sumQX=0;
                        maxQX=-10000000000;
                       for ( acttx=0; acttx<N_TX[4]; acttx++)
                       {
                           sumQX=sumQX+QX[itemp+  (N_TX[0]* (iic + ( N_TX[2] *acttx)))];
                           if (maxQX < QX[itemp+  (N_TX[0]* (iic + ( N_TX[2] *acttx)))] )
                           {
                                maxQX= QX[itemp+  (N_TX[0]* (iic + ( N_TX[2] *acttx)))] ;
                           }
                       }
                        
                  QNX = ((1-eps)* maxQX) + ((eps/N_TX[4])* (sumQX));
                  MMDX=MMDX+( PX[ix+ (N_TX[0]*(iix+  (N_TX[1]*(ic + (N_TX[2]* (iic + (N_TX[3] * actx)))))))] *( RX[ix+ (N_TX[0]*(iix+  (N_TX[1]*(ic + (N_TX[2]* (iic + (N_TX[3] * actx)))))))] + (gax*QNX)) );
                    }
               }              
                QX[ix + (N_TX[0]*(ic + (N_TX[2] * actx)))]  = MMDX ;
                BX[ix + (N_TX[0]*(ic + (N_TX[2] * actx)))]  = MMDX ;

                maxQ= fabs(qxu- QX[ix + (N_TX[0]*(ic + (N_TX[2] * actx)))]);
                if (d2>maxQ)
                    maxQ=d2;
                d2=maxQ;

    //             mexPrintf("************** d2=%f  ,  QX=%f , CI_r=%f *********** \n", d2, QXU[ix + (N_TX[0]*(actx))], CI_r);

            }
        }
    }

    if (d2<teta)
        break;
}





return;
}