#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
#define B_OUT plhs[0]
// #define BX_OUT plhs[1]
// #define BY_OUT plhs[2]
#define BH_OUT plhs[1]
// #define BHE1_OUT plhs[4]
// #define BHE2_OUT plhs[5]
// #define BHE3_OUT plhs[6]
    
#define Trns_S2NS_Action prhs[0]
#define Trns_X2NX_Action prhs[1]
#define Trns_Y2NY_Action prhs[2]
#define Trns_I2NI_Action prhs[3]
#define Trns_Ir2NIr_Action prhs[4]
#define Trns_Id2NId_Action prhs[5]
#define Trns_Il2NIl_Action prhs[6]
    
#define Reward_S_Action prhs[7]
#define Reward_X_Action prhs[8]
#define Reward_Y_Action prhs[9]
#define Reward_I_Action prhs[10]
#define Reward_Ir_Action prhs[11]
#define Reward_Id_Action prhs[12]
#define Reward_Il_Action prhs[13]
 
#define Q2 prhs[14]
#define Q2X prhs[15]
#define Q2Y prhs[16]
#define Q2I prhs[17]
#define Q2Ir prhs[18]
#define Q2Id prhs[19]
#define Q2Il prhs[20]

#define epsilon prhs[21]
#define gama prhs[22]
#define gamax prhs[23]
#define gamay prhs[24]
#define epi prhs[25]
#define Environment prhs[26]   
#define Delta prhs[27] 
#define NumC prhs[28]
#define LLJ prhs[29]
#define LLS prhs[30]
#define nhp prhs[31]
#define nhe prhs[32]
       

size_t K = mxGetNumberOfDimensions(Q2);
const mwSize *N = mxGetDimensions(Q2);
double *Q = mxGetPr(Q2);
size_t KX = mxGetNumberOfDimensions(Q2X);
const mwSize *NX = mxGetDimensions(Q2X);
double *QX = mxGetPr(Q2X);
size_t KY = mxGetNumberOfDimensions(Q2Y);
const mwSize *NY = mxGetDimensions(Q2Y);
double *QY = mxGetPr(Q2Y);

size_t KH = mxGetNumberOfDimensions(Q2I);
const mwSize *NH = mxGetDimensions(Q2I);
double *QHP = mxGetPr(Q2I);

size_t KHE1 = mxGetNumberOfDimensions(Q2Ir);
const mwSize *NHE1 = mxGetDimensions(Q2Ir);
double *QHE1 = mxGetPr(Q2Ir);

size_t KHE2 = mxGetNumberOfDimensions(Q2Id);
const mwSize *NHE2 = mxGetDimensions(Q2Id);
double *QHE2 = mxGetPr(Q2Id);

size_t KHE3 = mxGetNumberOfDimensions(Q2Il);
const mwSize *NHE3 = mxGetDimensions(Q2Il);
double *QHE3 = mxGetPr(Q2Il);

int W=0;
double NC = mxGetScalar(NumC);
double LL2S = mxGetScalar(LLS);
double LL2J = mxGetScalar(LLJ);
double NHP = mxGetScalar(nhp);
double *NHE = mxGetPr(nhe);

size_t K_T = mxGetNumberOfDimensions(Trns_S2NS_Action);
const mwSize *N_T = mxGetDimensions(Trns_S2NS_Action);
double *P = mxGetPr(Trns_S2NS_Action);
double *R = mxGetPr(Reward_S_Action);

size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);

size_t K_TY = mxGetNumberOfDimensions(Trns_Y2NY_Action);
const mwSize *N_TY = mxGetDimensions(Trns_Y2NY_Action);
double *PY = mxGetPr(Trns_Y2NY_Action);
double *RY = mxGetPr(Reward_Y_Action);

size_t K_TI = mxGetNumberOfDimensions(Trns_I2NI_Action);
const mwSize *N_TI = mxGetDimensions(Trns_I2NI_Action);
double *PI = mxGetPr(Trns_I2NI_Action);
double *RI = mxGetPr(Reward_I_Action);

size_t K_TIr = mxGetNumberOfDimensions(Trns_Ir2NIr_Action);
const mwSize *N_TIr = mxGetDimensions(Trns_Ir2NIr_Action);
double *PIr = mxGetPr(Trns_Ir2NIr_Action);
double *RIr = mxGetPr(Reward_Ir_Action);

size_t K_TId = mxGetNumberOfDimensions(Trns_Id2NId_Action);
const mwSize *N_TId = mxGetDimensions(Trns_Id2NId_Action);
double *PId = mxGetPr(Trns_Id2NId_Action);
double *RId = mxGetPr(Reward_Id_Action);

size_t K_TIl = mxGetNumberOfDimensions(Trns_Il2NIl_Action);
const mwSize *N_TIl = mxGetDimensions(Trns_Il2NIl_Action);
double *PIl = mxGetPr(Trns_Il2NIl_Action);
double *RIl = mxGetPr(Reward_Il_Action);


double *Env = mxGetPr(Environment);
double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *B, *BX, *BY, *BI, *BIr, *BId,*BIl, *BXY, *BXI, *BYI;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
double QN;
  
int ix,iix, actx, acttx;
double  sumQX, maxQX;
int itemp, jtemp, h1, h11, h2, h22, h3, h33, Hp, He, He2, He3;
int h4, h44, ic,iic;
double *X2, *Y2, *HP, *HE, *HE2, *HE3;
mxArray *X2Array, *Y2Array, *NHPArray, *NHEArray, *NHEArray2, *NHEArray3;


mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;
double QNX;

UAray = mxCreateDoubleMatrix( (N_T[6]*N_T[7]*N_T[8]*N_T[9]*N_T[10]*N_T[11]) , 1, mxREAL);
U = mxGetPr(UAray); 
PTempAray = mxCreateDoubleMatrix( (N_T[6]*N_T[7]*N_T[8]*N_T[9]*N_T[10]*N_T[11]) , 1, mxREAL);
PTemp = mxGetPr(PTempAray); 


UArayX = mxCreateDoubleMatrix( (N_TX[1]*N_TX[3]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[1]*N_TX[3]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 

UArayY = mxCreateDoubleMatrix( (N_TY[1]*N_TY[3] ) , 1, mxREAL);
UY = mxGetPr(UArayY); 
PTempArayY = mxCreateDoubleMatrix( (N_TY[1]*N_TY[3]) , 1, mxREAL);
PTempY = mxGetPr(PTempArayY); 

B_OUT = mxCreateNumericArray(K, N, mxDOUBLE_CLASS, mxREAL);
B = mxGetPr(B_OUT);

// BX_OUT = mxCreateNumericArray(KX, NX, mxDOUBLE_CLASS, mxREAL);
// BX = mxGetPr(BX_OUT);
//  
// BY_OUT = mxCreateNumericArray(KY, NY, mxDOUBLE_CLASS, mxREAL);
// BY = mxGetPr(BY_OUT);

BH_OUT = mxCreateNumericArray(KH, NH, mxDOUBLE_CLASS, mxREAL);
BI = mxGetPr(BH_OUT);

// BHE1_OUT = mxCreateNumericArray(KHE1, NHE1, mxDOUBLE_CLASS, mxREAL);
// BIr = mxGetPr(BHE1_OUT);
// 
// BHE2_OUT = mxCreateNumericArray(KHE2, NHE2, mxDOUBLE_CLASS, mxREAL);
// BId = mxGetPr(BHE2_OUT);
// 
// BHE3_OUT = mxCreateNumericArray(KHE3, NHE3, mxDOUBLE_CLASS, mxREAL);
// BIl = mxGetPr(BHE3_OUT);

// mexPrintf("teta=%f", teta);
X2Array = mxCreateDoubleMatrix( LL2J , 1, mxREAL);
X2 = mxGetPr(X2Array); 
Y2Array = mxCreateDoubleMatrix( LL2J , 1, mxREAL);
Y2 = mxGetPr(Y2Array); 
NHPArray = mxCreateDoubleMatrix( NHP , 1, mxREAL);
HP = mxGetPr(NHPArray); 
NHEArray = mxCreateDoubleMatrix( 2 , 1, mxREAL);
HE = mxGetPr(NHEArray);
NHEArray2 = mxCreateDoubleMatrix( 2 , 1, mxREAL);
HE2 = mxGetPr(NHEArray2);
NHEArray3 = mxCreateDoubleMatrix( 2 , 1, mxREAL);
HE3 = mxGetPr(NHEArray3);


while(true)
{
    d1=0;
     d2=0;
     d3=0;
    
    for ( i=1 ; i<(N_T[0]-1); i++)
    {
        for ( j=1; j<(N_T[1]-1); j++)
        {
            X2[0]=i-1;
            X2[1]=i;
            X2[2]=i+1;
            Y2[0]=j-1;
            Y2[1]=j;
            Y2[2]=j+1;
            
            for (h1=0; h1<(N_T[2]); h1++)
            {
                HP[0]=h1;
                if (h1==0)
                    {HP[1]=h1;}
                else
                    {HP[1]=h1-1;}
                for(h2=0; h2<(N_T[3]); h2++)
                {
                    HE[0]=h2;
                    if (h2==0)
                        {HE[1]=h2;}
                    else
                        {HE[1]=h2-1;}
                    for(h3=0; h3<(N_T[4]); h3++)
                    {
                        HE2[0]=h3;
                        if (h3==0)
                            {HE2[1]=h3;}
                        else
                            {HE2[1]=h3-1;}
                        for(h4=0; h4<(N_T[5]); h4++)
                        {
                            HE3[0]=h4;
                            if (h4==0)
                                {HE3[1]=h4;}
                            else
                                {HE3[1]=h4-1;}
                            
                            for ( act=0; act<N_T[12]; act++)
                             {
                              q= Q[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* (h3 + (N_T[4]* (h4 + (N_T[5]* ( act)))))))))))) ] ;
//                               if(i==3 && j==6 && h1==3 && h2==0 && act==0)
//                             { 
//                                 mexPrintf("=============== q=%f ============= \n", q );
//                             }
                              MMD=0;
                              for ( ii=0; ii<(N_T[6]) ; ii++)
                                {
                                 for ( jj=0; jj<(N_T[7]) ; jj++)
                                {    
                                    itemp= X2[ii];
                                    jtemp= Y2[jj];
                                    for (h11=0; h11<(N_T[8]); h11++)
                                    {
                                        Hp= HP[h11];
                                        for(h22=0; h22<(N_T[9]); h22++)
                                        {
                                            He= HE[h22];
                                            for(h33=0; h33<(N_T[10]); h33++)
                                            {
                                                He2= HE2[h33];
                                                for(h44=0; h44<(N_T[11]); h44++)
                                                {
                                                    He3= HE3[h44];
                                                    
                                                       sumQ=0;
                                                       maxQ=-10000000000;
                                                       for ( actt=0; actt<N_T[12]; actt++)
                                                       {
                                                           sumQ=sumQ+ Q[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* (He2 + (N_T[4]* (He3 + (N_T[5]* ( actt)))))))))))) ];
                                                           if (maxQ < Q[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* (He2 + (N_T[4]* (He3 + (N_T[5]* ( actt)))))))))))) ] )
                                                           {
                                                                maxQ=Q[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* (He2 + (N_T[4]* (He3 + (N_T[5]* ( actt)))))))))))) ] ;
                                                           }
                                                           // ------------------------------------------------------------------------------------
//                                                            if(itemp==3 && jtemp==6 && Hp==3 && He==0 && actt==0)
//                                                             { 
//                                                             mexPrintf(" In second loop: Q1=%f , Q2=%f  ************** \n", Q[itemp + (N_T[0]* (jtemp + (N_T[1]* (Hp + (N_T[2]* (He + (N_T[3]* ( actt)))))))) ]  , Q[3 + (N_T[0]* (6 + (N_T[1]* (3 + (N_T[2]* (0 + (N_T[3]* ( 0))))))))] );
//                                                             mexPrintf(" itemp=%d, jtemp=%d, Hp=%d, He=%d \n", itemp, jtemp, Hp, He);
//                                                            }                                                        
                                                        }
                                                        
                                                        QN=((1-eps)* maxQ) + ((eps/N_T[12])* (sumQ)); 
                                                        
                                                        
                                                        MMD=MMD+( P[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* (h3 + (N_T[4]* (h4 + (N_T[5]* ( ii + (N_T[6]* (jj + (N_T[7]* (h11 + (N_T[8]* (h22 + (N_T[9]* (h33 + (N_T[10]* (h44 + (N_T[11]*act))))))))))))))))))))))) ] * ( R[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* (h3 + (N_T[4]* (h4 + (N_T[5]* ( ii + (N_T[6]* (jj + (N_T[7]* (h11 + (N_T[8]* (h22 + (N_T[9]* (h33 + (N_T[10]* (h44 + (N_T[11]*act))))))))))))))))))))))) ] + (ga*QN)) ) ; 
//                                                         if(i==3 && j==6 && h1==4 && h2==1 && act==4 && h11==1 && h22==1 && ii==1 && jj==1)
//                                                         { 
// //                                                             mexPrintf("************** QN=%f, MMD=%f, P=%f, R=%f\n", QN, MMD, P[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act))))))))))))))) ], R [i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act))))))))))))))) ]);}
//                                                         if(i==3 && j==6 && h1==3 && h2==0 && act==0)
//                                                             { 
// //                                                             mexPrintf("============= QN=%f, MMD=%f, P=%f, R=%f\n", QN, MMD, P[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act))))))))))))))) ], R [i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( ii + (N_T[4]* (jj + (N_T[5]* (h11 + (N_T[6]* (h22 + (N_T[7] *act))))))))))))))) ]);}                                                        

//                                                         if (QN>0)
//                                                             { mexPrintf("**************QN*************\n");}
//                                                         if (MMD>0)
//                                                             { mexPrintf("11111111111111111MMD1111111111111\n");}
                                                     }
                                                 }
                                        }
                                    }

                                 }
                      }
                      
                        
                        
                           
                            Q[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* (h3 + (N_T[4]* (h4 + (N_T[5]* ( act)))))))))))) ] = MMD ;  // uper bound
                            B[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* (h3 + (N_T[4]* (h4 + (N_T[5]* ( act)))))))))))) ] = MMD ;  // uper bound
                                           
                           maxQ=fabs(q- Q[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* (h3 + (N_T[4]* (h4 + (N_T[5]* ( act))))))))))))]);
                           if (d1>maxQ)
                                   maxQ=d1;
                            d1=maxQ;
                            if(i==3 && j==6 && h1==3 && h2==0 && act==0)
                            { 
//                                 mexPrintf("=============== d1=%f , Q=%f ============= \n", d1, Q[i + (N_T[0]* (j + (N_T[1]* (h1 + (N_T[2]* (h2 + (N_T[3]* ( act))))))))]);
                            }
//                             if()
                            { 
//                                 mexPrintf("--------------- d1=%f , Q=%f ------------- \n", d1, Q[3 + (N_T[0]* (6 + (N_T[1]* (3 + (N_T[2]* (0 + (N_T[3]* ( 0))))))))]);
                            }
//                           mexPrintf("************** d1=%f  ,  Q=%f  ***************** \n", d1, Q[i +( N_T[0]*(j + (N_T[1]*act)))]);
                    
                            
                            
                            
                            }
                        }

                    }
                }
            }
        }
    }
//         mexPrintf("teta=%f, d1=%f \n", teta, d1);
      if (d1<teta)
        break;
        
} // end while

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

while(true)
{
    d3=0;
    for (ix=0; ix<N_TI[0]; ix++)
    {
        HP[0]=ix;
        if (ix==0)
            {HP[1]=ix;}
        else
            {HP[1]=ix-1;}
        
        for (ic=0; ic<N_TI[2]; ic++)
        {
        for (actx=0; actx<N_TI[4]; actx++)
        {
           
            qxu=QHP[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] ;
            MMDX=0;

          for ( iix=0; iix<N_TI[1]; iix++)
          {
              Hp= HP[iix];
              for ( iic=0; iic<NC; iic++ )
                {
                sumQX=0;
                maxQX=-10000000000;
               for ( acttx=0; acttx<N_TI[4]; acttx++)
               {
                   sumQX=sumQX+QHP[Hp+ (N_TI[0]*( iic +( N_TI[2]* acttx)))]  ;
                   if (maxQX < QHP[Hp+ (N_TI[0]*( iic +( N_TI[2]* acttx)))] )
                   {
                        maxQX= QHP[Hp+ (N_TI[0]*( iic +( N_TI[2]* acttx)))] ;
//                         mexPrintf("QHPU= %f, maxQ=%f \n", QHPU[iix+  (N_TI[0]*(acttx))], maxQX);
                   }
               }
                 QNX = ((1-eps)* maxQX) + ((eps/N_TI[4])* (sumQX));
                 MMDX=MMDX+( PI[ix+ (N_TI[0]*(iix + (N_TI[1]*( ic + (N_TI[2] * (iic + (N_TI[3] *actx)))))))] *( RI[ix+ (N_TI[0]*(iix+(N_TI[1]* ( ic + (N_TI[2] * (iic + (N_TI[3] *actx)))))))] + (gay*QNX)) );
                 }
          } 
            QHP[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] = MMDX ;
            BI[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))] = MMDX ;
           
            maxQ= fabs(qxu- QHP[ix + (N_TI[0]*(ic + (N_TI[2] * actx)))]);
            if (d3>maxQ)
                maxQ=d3;
            d3=maxQ;
            
//             mexPrintf("************** d3=%f  ,  QX=%f , CI_r=%f  , CI_p=%f *********** \n", d3, QHPU[ix + (N_TI[0]*(actx))], CI_r, CI_p);
            
        }
    }
    }
    
//             mexPrintf("teta=%f, d3=%f \n", teta, d3);

    if (d3<teta)
        break;
}



return;
}